; $Id: linux.inc,v 1.1 2002/05/27 23:44:59 hp Exp $
;- file          : linux.inc
; assembler     : nasm 0.98
; description   : linux kernel defined constants (from includes)

%ifndef __SYSTEM_INC
%error "this file must be included internally after asmutils' system.inc !"
%endif

%define linuxinc

%ifdef SYS__llseek; asmutils ..0.11 & linux system data
%define SYS_llseek SYS__llseek
%elifdef SYS_llseek; asmutils 0.12+
%define SYS__llseek SYS_llseek
%endif

%define _NSIG		64
%define _NSIG_BPW	32
%define _NSIG_WORDS	(_NSIG/_NSIG_BPW)
%define SIGRTMIN	32
%define SIGRTMAX	(_NSIG-1)

;-
;- signal.h

;-

; asmutils, kernel 2.4's version of oldsigaction
;	struc sigaction
;.sa_handler	ULONG	1
;.sa_flags	ULONG	1
;.sa_restorer	ULONG	1
;.sa_mask	resb	sigset_t_size
;	endstruc

;-
;- struc old_sigaction
;-	kernel 2.2. standard signal handler definition block
    struc old_sigaction
.hnd:	resd 1	;
.msk:	resd 1	;
.flg:	resd 1	;
.rst:	resd 1	;
    endstruc
;-
;- struc rt_sigaction	([hp] added the "rt_", for asmutils)
;-	kernel 2.4 (and 2.2. rt-) signal handler definition block
    struc rt_sigaction
.hnd:	resd 1	;handler
.flg:	resd 1	;SA_SIGINFO;flags
.rst:	resd 1	;NULL	; restorer ; (unused) -?- no! just glibc...
.msk:	resd 1	;NULL	; mask
.xtd:	resd 1	;NULL	; (extended)
    endstruc
;-
;- struc new_sigaction
;-	kernel 2.4 (libc?) signal handler definition block
    struc new_sigaction
.hnd:	resd 1	;
.act:	resd 1	;
.msk:	resd 1	;
.flg:	resd 1	;
.rst:	resd 1	;
    endstruc

;--------------------------------------------------------------------------
;-				System Calls
;--------------------------------------------------------------------------

%ifndef SYS_eax
%define SYS_eax eax
;- syscall entry, expecting all registers pre-set [hp/2000]
%macro sys_generic 0-6_nolist
	__syscall eax, 6, %0, %1, %2, %3, %4, %5, %6
%endmacro
%endif

;-
;- sys_uselib *path_to_library
%macro sys_uselib 0-1_nolist
	__syscall uselib, 1, %0, %1
%endmacro

;--------------------------------------------------------------------------
;arch/i386/
;--------------------------------------------------------------------------

;
;arch/i386/kernel/signal.c
;

;- sys_rt_sigaction 0-4
;-	int sig, const struct sigaction *act, struct sigaction *oact, size_t sigsetsize
%macro sys_rt_sigaction 0-4_nolist
	__syscall rt_sigaction, 4, %0, %1, %2, %3, %4
%endmacro

;- sys_rt_sigqueueinfo 0-3
;-	int pid, int sig, siginfo_t *uinfo
%macro sys_rt_sigqueueinfo 0-3_nolist
	__syscall rt_sigqueueinfo, 3, %0, %1, %2, %3
%endmacro

;--------------------------------------------------------------------------
;mm/
;--------------------------------------------------------------------------

;
;mm/filemap.c
;

;- sys_msync 0-3
;-	ulong start, size_t len, int flags
%macro sys_msync 0-3_nolist
	__syscall msync, 3, %0, %1, %2, %3
%endmacro

;--------------------------------------------------------------------------
;fs/
;--------------------------------------------------------------------------

;
;fs/open.c
;

;- sys_fchdir 0-1
;-	int fd
%macro sys_fchdir 0-1_nolist
	__syscall fchdir, 1, %0, %1
%endmacro

;-  sys_truncate 0-2
;-	char* path, off_t length
%macro sys_truncate 0-2_nolist
	__syscall truncate, 2, %0, %1, %2
%endmacro

;
;fs/buffer.c
;

;[hp'8/2000]
%macro sys_fsync 0-1_nolist; int fd
	__syscall fsync, 1, %0, %1
%endmacro
;[hp'11/2000]
%macro sys_fdatasync 0-1_nolist; int fd
	__syscall fdatasync, 1, %0, %1
%endmacro

;--------------------------------------------------------------------------
;kernel/
;--------------------------------------------------------------------------

;
;kernel/sched.c
;

;[hp] 24.10.2001
%macro sys_waitpid 0-3_nolist
	__syscall waitpid, 3,%0,%1,%2,%3
%endmacro

%macro sys_setgid 0-1_nolist
	__syscall setgid, 1, %0, %1
%endmacro

;--------------------------------------------------------------------------
;- linux.inc <eof>
