;-================================================================;
;- Copyright (C) 2001 H-Peter Recktenwald, Berlin <phpr@snafu.de>
;- Read ./doc/LEGAL file for copyright information (GNU GPL)
;-
;-  file	: nasmmac.inc
;-  switch	: __NASMMAC_I
;-  created	: 08-apr-2001
;-  modified	:
;-  version	: 0.01
;-  assembler	: nasm 0.98-3e
;-  description	: supplementary macroes
;-		:	which belong to the assembler:
;-		: _nolist, _listing_, list, jr, {A,T}MODE
;-  author	: H-Peter Recktenwald, Berlin <phpr@snafu.de>
;-  source	: -/-
;-  requires	: nasm 0.98e or later, patched vers. w/ "%xdefine"
;-================================================================;
;-

%ifndef __NASMMAC_I
%define __NASMMAC_I
%define nasmmacinc
;
;-
;- %define _nolist
;-	pre-definable macroes global listing on/off via asm-vari
;das, o groes erstaunen, spielt...
%ifndef _nolist
%define _nolist
%endif
;
;-
;- %macro list 0-*.nolist on;[nolist]
;-	useless substitute to upgraded (x.21+) nasm, to preventing "errors"
%ifndef _listing_
%macro list 0-*.nolist on;[nolist]
%define _listing_ %{1}
%endm
%ifidn _nolist,.nolist
%define _listing_ on
%else
%define _listing_ off
%endif
%endif
;-
;- %macro _message 0-*.nolist
;-	silly 'helper' to list macroes arguments by _content_
;-	required for old nasm-3e versions, inbuilt since xx.21
%ifndef _message_
%define _message_
%macro _message 0-*.nolist
%if %{0}>0
 %xdefine _msg_
 %rep %{0}
  %xdefine _msg_ _msg_ %{1}
  %rotate 1
 %endrep
 %error "_msg_"
%endif
%endm
%endif
;-
;- push_ibyte(imed)
;-	forcedly push dword by immediate byte
%define push_ibyte(x) db 0x6a,x
;-
;- s_<reg>, s_tor
;	internally for readad/writead (re below)
;-	disp into storage on tos from <pushad>
%define s_tor +32	; tos before <pushad>
%define s_eax +28
%define s_ecx +24
%define s_edx +20
%define s_ebx +16
%define s_esp +12
%define s_ebp +8
%define s_esi +4
%define s_edi
;-
;- readad 2
;-	read reg %1 from <pushad> reg %2 storage
%macro readad 2_nolist
    mov %{1},[byte esp s_ %+ %{2}]
%endm
;- writead 2
;-	store reg %2 to <pushad> reg %1 storage
%macro writead 2_nolist
    mov [byte esp s_ %+ %{1}],%{2}
%endm
;-

;-
;- dbplus 2-3
;-	insert db-s (or size %3) data items counting from %1 till (%2-1)
%macro dbplus 2-3_nolist db
%assign %%n %1
%rep %2-%1
    %3	%%n
%assign %%n %%n+1
%endrep
%endm
;-
;- dbcons 2-3
;-	insert %1 times db-s (or size %3) data items of value %2
%macro dbcons 2-3_nolist db
    times %1, %3 %2
%endm

;-
;- jr
;-	<jmp short>
%ifndef jr
%define jr jmp short
%endif
;-
;- disp
;-	<jcc/jmp disp [label|abs.expr]>
;-	cpl shortest branch code, backwards only.
%macro disp 1_nolist
%%d: equ $+4-(%{1})
%assign %%x %%d
%if (%%x<=0)&&(%%x>=0xFFFFFF80)
	%{00}	short %{1}
%elif (%%x>0)&&(%%x<0x80)
	%{00} short %{1}
%else
	%{00} near %{1}
%endif
%endm
;-
;- alignment by opcode:
;-
;- oalign 0-*,	opt. %1 alignment per byte value
;-	align by neutral opcode insertion or, <jmp short (disp-2)> if disp > 15
; a more efficient "align" macro for nasm 098e(+) or devel 0.98-08-09(+)
%define _align0_
; from AMD-64 binutils 2.11.90: Various efficient no-op patterns for aligning code labels. (comment in att-syntax!)
%define _align1_  db 0x90			; nop
%define _align2_  db 0x89,0xf6		; mov esi,esi
%define _align3_  db 0x8d,0x76,0x00		; lea 0(esi),esi
%define _align4_  db 0x8d,0x74,0x26,0x00	; lea 0(esi,1),esi
%define _align5_  db 0x90,0x8d,0x74,0x26,0x00; nop / lea 0(esi,1),esi
%define _align6_  db 0x8d,0xb6,0x00,0x00,0x00,0x00		; lea 0L(esi),esi
%define _align7_  db 0x8d,0xb4,0x26,0x00,0x00,0x00,0x00	; lea 0L(esi,1),esi
%define _align8_  db 0x90,0x8d,0xb4,0x26,0x00,0x00,0x00,0x00; nop / lea 0L(esi,1),esi
%define _align9_  db 0x89,0xf6,0x8d,0xbc,0x27,0x00,0x00,0x00,0x00	; mov esi,esi / lea 0L(edi,1),edi
%define _align10_ db 0x8d,0x76,0x00,0x8d,0xbc,0x27,0x00,0x00,0x00,0x00; lea 0(esi),esi / lea 0L(edi,1),edi
%define _align11_ db 0x8d,0x74,0x26,0x00,0x8d,0xbc,0x27,0x00,0x00,0x00,0x00	; lea 0(esi,1),esi / lea 0L(edi,1),edi
%define _align12_ db 0x8d,0xb6,0x00,0x00,0x00,0x00,0x8d,0xbf,0x00,0x00,0x00,0x00; lea 0L(esi),esi / lea 0L(edi),edi
%define _align13_ db 0x8d,0xb6,0x00,0x00,0x00,0x00,0x8d,0xbc,0x27,0x00,0x00,0x00,0x00; lea 0L(esi),esi / lea 0L(edi,1),edi
%define _align14_ db 0x8d,0xb4,0x26,0x00,0x00,0x00,0x00,0x8d,0xbc,0x27,0x00,0x00,0x00,0x00}; lea 0L(esi,1),esi / lea 0L(edi,1),edi
%define _align15_ db 0xeb,0x0d,0x90,0x90,0x90,0x90,0x90,0x90,0x90,0x90,0x90,0x90,0x90,0x90,0x90; jmp .+15; lotsa nops

%macro oalign 0-* 4_nolist 2,0	; alignment to 2^(%{1}), displaced by %{2}
;%macro a 0-2_nolist 2,0	; macro defaults don't work!
%assign %%a (1<<(%{1}))	; alignment
%%o: equ ($-$$)		; current offset in section
%%m: equ ((%%o)+(%%a)+(%{2})-1)&(~(%%a)); aligned address + disp
%assign %%s (%%m)-(%%o)
%if %%m < %%o
%assign %%s %%s+(%%a)
%endif
	_align %+ %%s %+ _
%endm

;-
;- alignp 1-3
;-	%2 +ve disp of final posn to an address > PC which is a multiple of %1: <alignp 8,3> 
;-	would advance to next (multiple of 8)-3 or, (multiple of 8)-3+8 if disp would be < 0
;-	as nasm-s align, otherwise, if %2 is not a numeric argument;
;-	3rd arg should then be put between "{..}" braces.
%imacro alignp 1-3.nolist
%if %{0}<2
	align %{1}
%else
    %ifnum %{2}
%%n: equ (($$-$)&((%1)-1))-%{2}
%assign %%c %%n
	%if %%n<0
%assign %%c %%c+%{1}
	%endif
	%if %{0}>2
	times %%c %{3}
	%else
	times %%c nop
	%endif
    %else
	align %{1},%{2}
    %endif
%endif
%endm
;-
;- AMODE 0-1
;-	<%assign (var) 0/1> to addressing mode of operand %1
;-	var = one of AER(unknown), REG, TXT(string), EA(other)
%macro TMODE 1.nolist
%assign TXT 0
%assign NUM 0
%assign REG 0
%assign EA  0
%assign AER 1
%ifnum %{1}
%assign NUM 1
%elifstr %{1}
%assign TXT 1
%else
%assign REG 1
    %ifnid %{1}
    %elifidni %{1},eax
    %elifidni %{1},ebx
    %elifidni %{1},ecx
    %elifidni %{1},edx
    %elifidni %{1},ebp
    %elifidni %{1},esi
    %elifidni %{1},edi
    %elifidni %{1},esp
%ifndef __LIB4TH
%elifndef __E4TH
%elifndef __F4
%else
    %elifidni %{1},PS
    %elifidni %{1},RS
    %elifidni %{1},BP
    %elifidni %{1},IP
    %elifidni %{1},UP
%endif
    %else
%assign REG 0
%assign EA  1
    %endif
%endif
%endm
%macro AMODE 0-*_nolist
%if %0>0
    TMODE {%{1}}
%else
    TMODE {%{00}}
%endif
%endm
;-
;- %macro min 2
%macro min 2
%if (%{1})<=(%{2})
%assign %{%m} (%{1})
%else
%assign %{%m} (%{2})
%endif
%xdefine %{00} (%{%m})
%endm
;- %macro max 2
%macro max 2
%if (%{1})>=(%{2})
%assign %{%m} %{1}
%else
%assign %{%m} %{2}
%endif
%xdefine %{00} (%{%m})
%endm
;-
%endif ;__NASMMAC_I
;-
;-================================================================;
;- nasmmac.inc <eof>
