;FILE "eforth.asm"
;- ===============================================================
;- eForth by Ting 1990, Muench, Rideau, Hohensee 1999,
;- mod. for nasm + asmutils-0.14+, hp'20010323 - phpr@snafu.de
;- ===============================================================
;-
%define __PROG eforth
%include "eforth.inc"
;[nolist]

;-
;- ================================================================
;-
list
CODESEG
Y:equ $$
    __CODESEG__
list off;[nolist]

%ifdef __AU_DBG
%ifndef debuginc
list off;[nolist]
%include "dbg.inc"	; debugging macros
;[list on]
%endif
%define __DBG
%else
%undef  __DBG
%macro DUMP 0-*
%endm
%macro PRNUM 0-*
%endm
%macro PRTXT 0-*
%endm
%macro PRSTG 0-*
%endm
%macro PFSYM 0-*
%endm
%endif
	__align

;- ================================================================
list

;- ****************  Main entry points and COLD start data ******************
;-

;-
;- %define {..}_sig	optionally disable active signal hnd's, set in "eforth.inc"
;%undef segv_sig
;%undef winch_sig
;%undef fpe_sig
;- %define app_to_boot STOIO	"!io" console int, single-keystroke zero-timeout mode.
%define app_to_boot STOIO
;-
START:
;- memory assignments, linux specific:
;-	[ r/x kernel | r/w kernel-data | r/w/x dictionary ) -> .bss ]
;-	[ .ss <- ( wordheaders | ps | tib | uvari | rs | .ss ]
;SM := SS_SZ+US_SZ+TIB_SZ+NM_SZ	; system-mem	towards lower addr ( headers | ps | |
;CM := DS_SZ+CS_SZ		; compile-mem	[ data & code ) extends into .bss
	_mov eax,CM
	_mov ecx,BSSTOP		; current mem-bot
	call allocbss		; allocate mem in .bss, set all to r/w/x
	lea esi,[dsp0+76]
%define iref byte esi-dsp0-76+
        mov [iref brkaddr],ebx	; .bss memtop
	mov [iref dctop],ecx	; page aligned bot. of dictionary
;- locate the start of the environment variables -> after .text set writeable! [hp]
        pop  ecx		; argc (prg. name inclusive) in ecx, argv is esp
        lea  eax, [esp+ecx*4+4]	; environ
        mov  [argc],ecx
        mov  [argv],esp
        mov  [environ],eax
	mov ebx,esp
	call palignm
	_push dword COLD
	push ebx
	pop esp
	mov [iref drp0],esp	; r0
	mov ebp,esp		; rp
	lea edi,[esp-RS_SZ+UD]
	mov [up2],edi		; uvari
	lea esp,[edi-UD+TIB_SZ]
	mov [iref dtib],esp	; tib, s0
	lea ecx,[esp-SS_SZ]	; top(!) of header space, extends .ss towards lower addr
	_push 0
	mov [iref dntop],ecx
	mov [iref dsp0],esp	; sp
	mov eax,esp
	lea esp,[ecx-NM_SZ]
	push eax		; init .ss section to header-space bottom
	pop esp
%ifdef sig_hnd
	call isegf
%endif
        mov esi,COLD.1		; initialize IP
	__NEXT			;
warm:A
	mov UR,[up2]
	mov RS,[uref uR0]
; 11 cells put to tos by sighnd if in interpreter loop, no extra data otherwise.
; -> leave PS as is, ioctl/select console-i/o to not reponding to sigquit -?-
	cmp IP,PS
	jc .s
; depends on no. of fd-s(?) and/or sys_select args, by "w4i": +11 cells for left off watching mode bit-table.
	lea PS,[PS+11*CELSZ]
.s:
	cmp PS,[uref uS0]
	jc .u
	mov PS,[uref uS0]
.u:
	mov dword[sgf],0
	mov esi,COLD.2
	__NEXT
cold:
        mov esi,COLD.3		; initialize IP
	__NEXT			;
        __DATASEG__
        __align
; COLD start moves the following to USER vari
; which MUST REMAIN IN ORDER OF USER VARIABLES.
;-
;- { 0 +origin }	base addres of cold-start defaults
;- origin:	indirect(!) cold-start entry
origin:	dd cold;COLD.1	;	; 00	; indirect(!) cold-start entry
;-  04		indirect(!) warm-start entry
	dd warm;WARM.1
;U0:			;-80; U0 = UR-80; reserved space in user area
; { 0 +origin }		; +UP	; +origin
UFIRST:
UZERO:	equ UFIRST-4*CELSZ; U0 = UR-80	; bot. of user area
deof:	dd 0		;-70	; 08	; (1st named uvari)
argc:   dd 0		;
argv:   dd 0		;	; 10	;
environ:dd 0
brkaddr:dd 0		;-60	;	; .bss memtop
;- $1c		SP0
dsp0:	dd 0	; SPP	;	;	; SP0
;-  20		RP0
drp0:	dd 0	; RPP	;	; 20	; RP0
;-  24		'?KEY
dqrx:	dd QRX		;	;	; '?KEY
;-  28		'EMIT
dtxsto:	dd TXSTO	;-50	;	; 'EMIT
;xio:  Reset the I/O vectors 'EXPECT, 'TAP, 'ECHO and 'PROMPT.
;-  2c		'EXPECT
dxpect:	dd ACCEP	;	;	; 'EXPECT\
;-  30		'TAP	(input chars storage and pointer increment)
dtap:	dd KTAP		;	; 30	; 'TAP	  \
;-  34		'ECHO
decho:	dd TXSTO	;	;	; 'ECHO   /
;-  38		'PROMPT
dprompt:dd DOTS		;-40	;	; 'PROMPT/
dbase:	dd DBASE	;	;	; BASE
	dd 0		;	; 40	; tmp
dspan:	dd 0		;	;	; SPAN
dtoin:	dd 0		;-30	;	; >IN
dntib:	dd 0		;	;	; #TIB
dtib:	dd 0		; TIBB	; 50	; TIB
	dd 0		;	;	; CSP
;-  58		'EVAL
deval:	dd INTER	;-20	;	; 'EVAL
;-  5c		'NUMBER
dnumber:dd NUMBQ	;	;	; 'NUMBER
	dd 0    	;	; 60	; HLD
dhandl:	dd 0		;	;	; HANDLER
;-  68		'M/MOD, dft symmetric "sm/rem"
dummod:	dd SMBYR	;-10	;	; 'M/MOD, default is sm/rem, symmetric(!)
ddpl:	dd 0		;	;	; DPL
dbcib:	dd 0		;	; 70	; for compiler/interpreter
dstdin:	dd STDIN	;	;	; (in)
dstdout:dd STDOUT	;  0	;	; (ou)
dstderr:dd STDERR	;  	;	; (er)
dkbd:	dd -1		;	; 80	; (kb)
	dd FORTH.v	;	;	; CONTEXT pointer
dvocs:	dd FORTH.v
%ifdef def_vocs
	dd ROOT.v
	dd SYSTEM.v
	dd FORTH.v
%endif
	times NVOCS-(($-dvocs)/4) dd 0;(+20); vocabulary stack - see NVOCS
	dd 0		; 30	;	; CURRENT pointer
	dd 0		;	;	; vocabulary link pointer
dctop:	dd BSSTOP	;	; b0	; CP
dntop:	dd 0		;	;	; NP
dlastn:	dd LASTN	; 40	;	; LAST
dbits:	dd 0		;	;	; (bits)
;-  c0		'TYPE
dtype:	dd TYPEC	;	; c0	; 'TYPE
;-  c4		WIDTH
dwidth:	dd NWIDTH	;	;	; WIDTH
;-  c0		UP
dup:	dd ULAST-UZERO	; -?-	; -?-	; UP
;
ULAST:
;-  cc		ptr all lower case characters code table
dhilo:	dd tlochar	;	; c4	;
;-  d0		ptr all upper case characters code table
dlohi:	dd thichar	;	;	;
;
ttyst:A
;-	defaults for "stty sane"
.iflag:
	dd 0x00002102
.oflag:
	dd 0x00000005
.cflag:
	dd 0x000004bf
.lflag:
	dd 0x00008A3B
.lineb:
	db 0
.termio:
;-	do not use asmutils' data as defaults: values are char positions in structure!
	db 0x03
	db 0x1C
	db 0x7F
	db 0x15
	db 0x4
	db 0x0
	db 0x1
	db 0x0
	db 0x11
	db 0x13
	db 0x1A
	db 0x0
	db 0x12
	db 0x0F
	db 0x17
	db 0x16
	db 0x0
	times NCCS-($-.termio) db 0
;
thichar:A;upper case letters
	dbplus   0, 97	;000..096
	dbplus  65, 91	;097..122
	dbplus 123,224	;123..223
	dbplus 192,223	;224..254
	db 255
;
tlochar:A;lower case letters
	dbplus   0, 65	;000..064
	dbplus  97,123	;065..090
	dbplus  91,192	;091..191
	dbplus 224,256	;192..223
	dbplus 224,256	;224..255
;
nbase:A
    	db 1,2,0,4,0,0,0,8,0,10,0,12,0,0,0,16;;,-1;
npref:A
    	db '"%.!...&.#....$',0;;\',0;
.e:
;
ttyt:A
	db "/dev/tty",0
HI.s:A
	stng ,{AC_LF,"eForth v",REL|48,".",VER|48,"-",EXT>>8|48,EXT&255|48,AC_LF}
;
sysc:A
 db   0	; control marker
.exit:
%include "scdata.inc"
sysc.enum:A
 dw (control-$)/2
 dw sysc.exit-$
 dw sysc.enum-$
control:A; Some hardcoded console cmds (Linux/XTerm)
.ho: db 27,"[H",0	; cursor_home,          ho - home position */
.le: db 27,"[D",0	; cursor_left,          le - cursor left */
.nd: db 27,"[C",0	; cursor_right,         nd - right one column */
.up: db 27,"[A",0	; cursor_up,            up - up one column */
.do: db 27,"[B",0	; cursor_down,          do - down one column */
.cl: db 27,"[H",27,"[J",0;clear_screen,         cl - clear screen and home */
.cd: db 27,"[J",0	; clr_eos,              cd - clear down */
.ce: db 27,"[K",0	; clr_eol,              ce - clear to end of line */
.bl: db 7,0		; bell,                 bl - bell 
.dc: db 27,"[P",0	; delete_character,     dc - delete character in line
.dl: db 27,"[M",0	; delete_line,          dl - delete line from screen
.sf: db 27,"D",0	; scroll_forward,       sf - scroll screen up (XTerm ??) */
.sr: db 27,"M",0	; scroll_reverse,       sr - scroll screen down */
.so: db 27,"[2m",0	; enter_standout_mode,  so - enter standout mode (half bright)
.se: db 27,"[22m",0	; exit_standout_mode,   se - normal intensity
.us: db 27,"[4m",0	; enter_underline_mode, us - turn on underline mode
.ue: db 27,"[24m",0	; exit_underline_mode,  ue - turn off underline mode
.md: db 27,"[1m",0	; enter_bold_mode,      md - enter double bright mode */
.mr: db 27,"[7m",0	; enter_reverse_mode,   mr - enter reverse video mode */
.mb: db 27,"[5m",0	; enter_blink_mode,     mb - enter blinking mode (XTerm??) */
.me: db 27,"[0m",0	; exit_attribute_mode,  me - turn off all appearance modes */
.25: db 27,"[25m",0	; blink off
.27: db 27,"[27m",0	; reverse video off
.xy: db 27,'[6n',0	; ret cursor posn
.ris:db 27,'c',0	; reset
.sc: db 27,'7',0	; save state (attr, curs, charsets)
.rc: db 27,'8',0	; most recently saved state
.enum:A
	dw (linux-$)/2
	dw .ho-$
	dw .le-$
	dw .nd-$
	dw .up-$
	dw .do-$
	dw .cl-$
	dw .cd-$
	dw .ce-$
	dw .bl-$
	dw .dc-$
	dw .dl-$
	dw .sf-$
	dw .sr-$
	dw .so-$
	dw .se-$
	dw .us-$
	dw .ue-$
	dw .md-$
	dw .mr-$
	dw .mb-$
	dw .me-$
	dw .25-$
	dw .27-$
	dw .xy-$
	dw .ris-$
	dw .sc-$
	dw .rc-$
	dw .enum-$
linux:A;_rawkey_string[]; Strings sent by function keys
.k1: db  27,"[[A",0	; .k1 - function keys 1 - 4
.k2: db  27,"[[B",0	; .k2
.k3: db  27,"[[C",0	; .k3
.k4: db  27,"[[D",0	; .k4
.k5: db  27,"[[E",0	; .k5
.k6: db  27,"[17~",0	; .k6
.k7: db  27,"[18~",0	; .k7
.k8: db  27,"[19~",0	; .k8
.k9: db  27,"[20~",0	; .k9
.k0: db  27,"[21~",0	; .k0
.kl: db  27,"[D",0	; .kl - arrow left
.kr: db  27,"[C",0	; .kr - arrow right
.ku: db  27,"[A",0	; .ku - arrow up
.kd: db  27,"[B",0	; .kd - arrow down
.kh: db  27,"[1~",0	; .kh - home key
.kH: db  27,"[4~",0	; .kH - home down key (end key)
.kN: db  27,"[6~",0	; .kN - next page
.kP: db  27,"[5~",0	; .kP - previous page
.kb: db  27,"[D",0	; .kb - backspace key
.kD: db  27,"[3~",0	; .kD - delete character key
.kI: db  27,"[2~",0	; .kI - insert character key
.enum:A
	dw (xterm-$)/2
	dw .k1-$
	dw .k2-$
	dw .k3-$
	dw .k4-$
	dw .k5-$
	dw .k6-$
	dw .k7-$
	dw .k8-$
	dw .k9-$
	dw .k0-$
	dw .kl-$
	dw .kr-$
	dw .ku-$
	dw .kd-$
	dw .kh-$
	dw .kH-$
	dw .kN-$
	dw .kP-$
	dw .kb-$
	dw .kD-$
	dw .kI-$
	dw .enum-$
xterm:A;_rawkey_string[]; Strings sent by function keys */
.k1: db  27,"[11~",0	; .k1 - function keys 1 - 4 */
.k2: db  27,"[12~",0	; .k2 */
.k3: db  27,"[13~",0	; .k3 */
.k4: db  27,"[14~",0	; .k4 */
.k5: db  27,"[15~",0	; .k5 */
.k6: db  27,"[17~",0	; .k6 */
.k7: db  27,"[18~",0	; .k7 */
.k8: db  27,"[19~",0	; .k8 */
.k9: db  27,"[20~",0	; .k9 */
.k0: db  27,"[21~",0	; .k0 */
.kl: db  27,"OD",0	; .kl - arrow left */
.kr: db  27,"OC",0	; .kr - arrow right */
.ku: db  27,"OA",0	; .ku - arrow up */
.kd: db  27,"OB",0	; .kd - arrow down */
.kh: db  27,"[1~",0	; .kh - home key ?? */
.kH: db  27,"[4~",0	; .kH - end key ?? */
.kN: db  27,"[6~",0	; .kN - next page */
.kP: db  27,"[5~",0	; .kP - previous page */
.kb: db  27,"[D",0	; .kb - backspace key */
.kD: db  27,"[3~",0	; .kD - delete character key ?? */
.kI: db  27,"[2~",0	; .kI - insert character key */
.enum:A
	dw (colour-$)/2
	dw .k1-$
	dw .k2-$
	dw .k3-$
	dw .k4-$
	dw .k5-$
	dw .k6-$
	dw .k7-$
	dw .k8-$
	dw .k9-$
	dw .k0-$
	dw .kl-$
	dw .kr-$
	dw .ku-$
	dw .kd-$
	dw .kh-$
	dw .kH-$
	dw .kN-$
	dw .kP-$
	dw .kb-$
	dw .kD-$
	dw .kI-$
	dw .enum-$
colour:A
.28:
.29:
.30: db 27,"[30m",0	; black foreground
.31: db 27,"[31m",0	; red foreground
.32: db 27,"[32m",0	; green foreground
.33: db 27,"[33m",0	; brown foreground - (very, almost invisible) dark yellow
.34: db 27,"[34m",0	; blue foreground
.35: db 27,"[35m",0	; magenta foreground
.36: db 27,"[36m",0	; cyan foreground
.37: db 27,"[37m",0	; white foreground
.38: db 27,"[38m",0	; underscore on, set default foreground color
.39: db 27,"[39m",0	; underscore off, set default foreground color
.40: db 27,"[40m",0	; black background
.41: db 27,"[41m",0	; red background
.42: db 27,"[42m",0	; green background
.43: db 27,"[43m",0	; brown background
.44: db 27,"[44m",0	; blue background
.45: db 27,"[45m",0	; magenta background
.46: db 27,"[46m",0	; cyan background
.47: db 27,"[47m",0	; white background
.48:
.49: db 27,"[49m",0; default background color
.enum:A
	dw (cstrings-$)/2
	dw .30-$
	dw .31-$
	dw .32-$
	dw .33-$
	dw .34-$
	dw .35-$
	dw .36-$
	dw .37-$
	dw .38-$
	dw .39-$
	dw .40-$
	dw .41-$
	dw .42-$
	dw .43-$
	dw .44-$
	dw .45-$
	dw .46-$
	dw .47-$
	dw .48-$
	dw .49-$
	dw .enum-$
cstrings:A
.enum:
	dw (.e-$)/2
	dw control.enum-$	;0 console
	dw linux.enum-$		;1 console F-keys
	dw xterm.enum-$		;2 xterm F-keys
	dw colour.enum-$	;3 colours
	dw sysc.enum-$		;4 syscalls names list
	dw .enum-$		;. end marker
.e:
; several (3+) different signals handlers defn's exist.
; I'd whish those "programmers" would make their mind up...
;'old_sigaction':
;    dd r	; handler
;    dd NULL	; restorer (_is_ used!)
;    dd SA_SIGINFO;flags
;    dd NULL	; mask
;    dd NULL	; mask
;'new' works for standard sig's, too:
%ifndef sig_hnd
%undef fpe_sig
%undef winch_sig
%undef ileg_sig
%undef segv_sig
%undef quit_sig
%else
;- signals which exit
sa_x:A
	dd b	; handler
	dd SA_SIGINFO;flags
	dd NULL	; restorer (_is_ used!)
	dd NULL	; mask
	dd NULL	; (extended)
;- signals which send a message
sa_i:
sa_m:		;sigaction
	dd r	; handler
	dd SA_SIGINFO;flags
	dd NULL	; restorer
	dd NULL	; mask
	dd NULL	; (extended)
%ifdef winch_sig
sa_winch:;- winch is quiet
%ifdef winch_sig
	dd winch	; handler
%else
	dd return
%endif
	dd SA_SIGINFO;flags
	dd NULL	; restorer
	dd NULL	; mask
	dd NULL	; (extended)
%endif
%ifdef fpe_sig
sa_fpe:;- fpe exits
	dd fpe	; handler
	dd SA_SIGINFO;flags
	dd NULL	; restorer
	dd NULL	; mask
	dd NULL	; (extended)
%endif
%ifdef segv_sig
sa_segv:
	dd segv	; handler
	dd SA_SIGINFO;flags
	dd NULL	; restorer
	dd NULL	; mask
	dd NULL	; (extended)
%endif
%ifdef quit_sig
sa_quit:
	dd quits; handler
	dd SA_SIGINFO;flags
	dd NULL	; restorer
	dd NULL	; mask
	dd NULL	; (extended)
%endif
%endif
        __DATASEG__
BASEN: 
        __CODESEG__

;- ************************  os-dependant support routines ******************
; --
; i:	eax	bytes to allocate
;	ecx	current bottom
; o:	eax	new membot (old memtop)
;	ecx	size
;	other	reg's preserved
; - use same routine for <reloc> w. different ptr-s -
allocbss:A;:ok:	; ebx=new-top, eax=size, ecx=old-top=new-bot
	mov ebx,ecx
	call palign
	mov ecx,ebx
	mov ebx,eax
	call palign
	mov eax,ebx
	push ecx
	push eax
	lea ebx,[ecx+eax]	; requested top address
	mov ecx,eax		; save size
	sys_brk		; .bss extend bot. up
	cmp eax,-4096
	push eax
	ja .x		;?; error
;?; -> for compile-space, only (dictionary)
	sub eax,ecx
	sys_mprotect eax,ecx,PROT_READ|PROT_WRITE|PROT_EXEC
	_cmp eax,-4096
	jna .x
;?;all other .bss memory just dataspace
	sys_mprotect ebx,ecx,PROT_READ|PROT_WRITE
	_cmp eax,-4096
.x:
	pop ebx
	pop eax
	pop ecx
return:
	ret
;
palign:A
	add ebx,PAGE_SIZE-1
palignm:
	and ebx,PAGE_MASK
	ret
;
;- signals which restore terminal & exit
;		; 3         2         1         0
;		;10987654321098765432109876543210
%assign sgnsys   01010101000100000010000100101000b	; use special or, parent's hnd
%assign sgnsys	sgnsys&~(fpesig|winchsig|segvsig|ilegsig|quitsig)
;		 fedcba9876543210fedcba9876543210
%assign sgmask   01000001011000011000101011010110b	; exitting, else message
%assign sgmask	 sgmask|fpesig|winchsig|segvsig|ilegsig|quitsig
;		 UpIwPVxXuTtTsCcStApUsUkFbAtIqIh
;		 NwOiRTfCrTtStOhTeLiSeSiPuBrLuNu
;		 Ur nOAsPgOiToNlKrRpRgRlEsRaLiTp
;		 S  cFLzU UnPpTdFmMe2v1l  Tp t  
;		 E  h R         L
;		 D    M         T
%ifdef sig_hnd
isegf:A
	pushad
	_mov edi,0
	mov edx,edi
	lea ebx,[edi+31]		; available signal no's, 1..31
	lea esi,[edi+_NSIG/8]
.l:
	mov eax,sgnsys		; signals which remain unchanged
	bt eax,ebx
	jc .t			;?; rt-signal, only
	mov ecx,sa_x		; handler for exit sgs
	mov eax,sgmask		; signals which exit
	bt eax,ebx
	jc .s			;?; sig-exit
	add ecx,byte sa_i-sa_x
.s:
	sys_rt_sigaction
; rt signals
.t:
	add ebx,byte SIGRTMIN
	sys_rt_sigaction EMPTY,sa_m
	sub ebx,byte SIGRTMIN+1
	jns near .l
%ifdef fpe_sig
	sys_rt_sigaction SIGFPE,sa_fpe
%endif
; winch_sig always silent, w/ or w/o vari setting
	sys_rt_sigaction SIGWINCH,sa_winch
%ifdef ileg_sig
	sys_rt_sigaction SIGBUS,sa_segv
	sys_rt_sigaction SIGILL,sa_segv
%endif
%ifdef segv_sig
	sys_rt_sigaction SIGSEGV,sa_segv
%endif
%ifdef quit_sig
	sys_rt_sigaction SIGQUIT,sa_quit
%endif
	popad
	ret
; ! 1st level subroutine !
; regs unchanged, eflags=Z if signal from <hupjobs>, else NZ
;- store signo in (eof) for <byes> if @(eof) was < 2
;- if compiled from source w. __AU_DBG swich %define-d, 
;-	display signal no. & location of occurrence
sigr:A
	push edx
	push ecx
	lea edx,[esp+8+8]
	mov ecx,[edx]
	mov edx,[edx+8]	; arg(2)
	mov edx,[edx+19*4]	; posn(19) -> pc at offending opr, pc
	cmp dword[uref uPEOFP],byte 1
	jg .h
	neg ecx
	E4PN ecx,s,'SG:$'
	E4PN edx,l,'at:'
	sub edx,Y
	E4PN edx,s,'4th:'
.h:
    %ifdef hup_jobs
	cmp edx,hupjobs.k
	jz .b	;?; prevent false signo from internal call
    %endif
	mov [uref uPEOFP],ecx
.b:
	pop ecx
	pop edx
%endif
	ret
;
; print (un)signed sedecimal eax, stg(ecx,edx)
e4pn:A
	xor ebx,ebx
	jr .g
.s:;	;<signed)
	mov ebx,eax
	sar ebx,24
	mov bl,8
	jns .g
	neg eax
.g:
	push ebx
	push eax
	push edx
	sys_write STDERR,esp,4
	pop eax
	pop eax
	pop ebx
.n:
	_sub esp,12
	mov byte[esp],' '
	mov ecx,8
.l:
	mov dl,15
	and dl,al
	cmp dl,10
	jc .a
	add dl,7
.a:
	add dl,'0'
	mov [esp+ecx],dl
	dec bl
	js .x
	test eax,eax
	jz .r
.x:
	shr eax,4
	dec ecx
	jg .l
.r:
	_mov edx,9
	lea ecx,[esp+ecx]
	test bl,bl
	js .p
	test ebx,ebx
	movzx ebx,bl
	jns .o
	dec ecx
	inc edx
	mov byte[ecx],'-'
.o:
	inc ebx
	sub edx,ebx
.p:
	mov byte[ecx+edx],' '
	inc edx
	sys_write STDERR
	_add esp,12
	ret
;
hupjobs:A
%ifdef hup_jobs
	pushad
	sys_getgid	; process group
	mov ebx,eax
	_mov ecx,SIGHUP
	neg ebx
	sys_kill	; remove tasks but not caller
.k:
	popad
%endif
	ret
;
%ifdef fpe_sig
fpe:A; special entries for idiv ebx, div ebx, 
; others should supply entry to hnd on stack and remove immediately after div opr.
; on stack supplied handler should continue in dividing 4th word after div opr.
	pushad
	lea eax,[esp s_tor+4]; tor
	mov eax,[eax+8]	; arg(2)
	lea edx,[eax+19*4]; posn(19) -> pc at offending opr
	mov ecx,fpebx	; div error hnd, div by @ecx
	mov eax,[edx]
	mov eax,[eax]
	cmp ah,0xf3	; div
	jz .g		;?; ebx
	mov ecx,fpebxi	; hnd idiv by @ebx
	cmp ah,0xfb	; idiv
	jz .g
	mov ecx,.a	; ret into supplied handler
.g:
	mov [edx],ecx	; sto handler
	popad
.a:
	ret
%endif
%ifdef segv_sig
segv:A
	inc dword[sgf]
	_cmp dword[sgf],1
	jg b
	call sigr
	push eax	;;;-?-
	mov eax,[esp+4+8]; arg(2)
	mov dword[eax+19*4],cold; posn(19) -> pc at offending opr
	pop eax		;;;-?-
	ret
%endif
%ifdef quit_sig
; restart by <CTR"\"> key
quits:A
	push eax	;;;-?-
	mov eax,[esp+4+8]; arg(2)
	mov dword[eax+19*4],JWARM.j; posn(19) -> pc
	pop eax
	ret
%endif
%ifdef sig_hnd
;- (display signo & pc,) pass signo to bye & exit.
b:A
	call sigr
	jmp byes
;
;- (display signo & pc,) continue main program.
r:A
	call sigr
	jmp return
%endif
%ifdef fpe_sig
fpebx:A; div 0, div ovf
	cmp ebx,1
	jz rpureg	;?; ovf from div 1
	jc rzreg	;?; div 0
	push eax	; dvd.hi
	mov eax,edx	; dvd.hi
	xor edx,edx
	div ebx
	pop eax	; dvd.lo
	div ebx	; leave rmd
	ret
fpebxi:A; idiv 0, idiv ovf
	cmp ebx,-1
	jz rmureg	;?; ovf from div -1
	jl .d	;?; other -ve
	cmp ebx,1
	jz rpureg	;?; ovf from div 1
	jl rzreg	;?; div0
.d:
	push eax	; dvd.hi
	mov eax,edx	; dvd.hi
	xor edx,edx
	idiv ebx
.l:
	mov edx,eax
	pop eax		; dvd.lo
	idiv ebx	; leave rmd
	ret
ruureg:A
	inc edx
	jz rpureg
	dec edx
	jz rpureg.r
	neg edx
	mov eax,edx
rmureg:A
	neg eax
rpureg:
	mov edx,0
.r:
	ret
rzreg:A
	or eax,edx
	jz .e	;?; 0/0
	sar edx,31
	not edx	; +ve:-1 -ve:0
	lea eax,[edx*2+0x80000001];q: +/- max
	mov edx,eax
	ret
.e:A
	inc eax
	ret
%endif
%ifdef winch_sig
; SIGWINCH handler, updates main console window sizes for {max-xy} - n.i. -
winch:A
;	mov [uref uBWSB],eax
	ret
%endif

;- ************************ OS-dependent Forth  ******************************

; -- headerless --

; for "kbd'"
__CODE 0,'kb[',KBB
	cmp dword[uref uPKBP],byte 0
	__ENTER
	jns .r	;?; already open
	call kbopen
.r:
	mov eax,[uref uPINP]
	mov ecx,[uref uPKBP]
	mov [uref uPINP],ecx
	mov [uref uPKBP],eax
	__NEXT
;
	__CODE 0,']kb',BKB
	mov ecx,[uref uPINP]
	mov eax,[uref uPKBP]
	__ENTER
	mov [uref uPKBP],ecx
	mov [uref uPINP],eax
	__NEXT

; -- vocabularies --

vocbase:A
	dd 0,0	; base of voc- & word-links
.y:
	dd 0,0	; noname
;word-header:
; cde:	N[ cfa | lfa | nfa (L{name}.b "name")  4-aligned,0 ]
;	C[ 4-aligned,nop {name}:
; col:	N[ cfa | lfa | nfa (Lc{name}.b "name") 4-aligned,0 ]
;	C[ 4-aligned,nop c{name}: | 2e,2e,2e,call dolist, {name}:
; voc:	N[ cfa | lfa | nfa (Lc{name}.b "name") 4-aligned,0 ]
;	C[ 4-aligned,nop c{name}: | 2e,2e,2e, {name}: call dolist, dovoc, vhead, vlink
;;- doVoc	( -- )				(c)
;;-	Run time action of VOCABULARIES.
;__CODE COMPO+5,"doVoc",DOVOC	; -20
;	lea ecx,[IP+2*CELSZ]
;	rpop IP
;	mov [uref uCNTXT],ecx
;	__NEXT
;;- doVar	( -- a )			(c)
;;-	Run time routine for VARIABLE & CREATE.
;__CODE COMPO+5,"doVar",DOVAR
;	push @TOS
;	lea @TOS,[IP+CELSZ]
;	rpop IP
;	__NEXT
__COLON IMEDD|5,"forth",FORTH
	dd DOVOC		; == DOVAR
;__CODE IMEDD|1,"forth",FORTH
;	alignp 4,1
;	call dovoc
.l:	dd 0			; vocabulary link pointer, stored to {context} etc.
.v:	dd LASTFTH,0		; vocabulary head pointer
dovoc:A
	pop ecx
	rpop IP
	mov [uref uCNTXT],ecx
	__NEXT
;- pnum		( r -- )
;-	hi-level debugging, r = index to pushad'd structure & data at tos+
;-	indices r: tos=8, regs: eax=7, ecx=6, edx=5, ebx=4, esp=3, ebp=2, esi=1, edi=0
__CODE 6,"pnum",PRNUM4
	pushad
	mov ebx,[esp+ebx*4]
	E4PN ebx,l,'N:'
	popad
	__ENTER
	pop ebx
	__NEXT
;-
;- -- cpu specific --
;-

;- cpuid	( n -- a b c d )
;-	fetch processor identification, sync caches
__CODE 1,'cpuid',CPI
	mov eax,ebx
	__ENTER
	cpuid
	push eax
	push ebx
	push ecx
	mov ebx,edx
	__NEXT
;- tick		( -- dn )
;-	reads the cpu timer, the <rdtsc> cpu opr.
__CODE 1,'tick',RTIK
	spush
	__ENTER
	rdtsc
	mov @TOS,edx
	spush eax
	__NEXT
;-
;- -- host access --
;-

;- bye		( -- )
;-	Exit eForth.
__CODE 3, "bye", BYE
	call kbopen
	mov dword[uref uPEOFP],0
byes:;	<from signals)
	mov ebx,[uref uPEOFP]
	call sttys
	call hupjobs
	sys_exit
;-
;- cstg		( n1 n2 -- a2 u )
;-	index list# -- stg count, ptr to "null$" if n1,n2 out of range
;-	index 0..3 for terminal control:
;-		0:ctrls, 1:F-console, 2:F-xterm, 3:colours
;-	{ 0 4 cstg } returns ptr & sum of length's of syscalls names
;-	{ 0 5 cstg } returns ptr & sum of length's of colour-strings
;-	names in sequence of the rsp. numbers, as asciz string, for "sys".
__CODE 4,'cstg',CSTG
	mov eax,[PS]		; n1
	__ENTER
	call .c
	mov [PS],ecx
	__NEXT
.c:A
	mov edx,cstrings
	cmp bx,[edx]
	jnc .o			;?; list# out of range
	lea ecx,[ebx*2+edx+2]	;string#, ptr to list indices
	movsx ebx,word[ecx]
	add ecx,ebx		;list.enum
	cmp ax,[ecx]		;range top
	jnc .o			;?; stg# out of range
	lea ecx,[ecx+2*eax+2]	;ptr
	movsx edx,word[ecx]
	movsx ebx,word[ecx+2]	;next
	add ecx,edx		;text
	sub ebx,edx		;len
	inc ebx
	ret
.o:A
	mov dword[PS+4],NULLS.s
	mov ebx,0
	ret
;-
;- (s)		( a -- n | er )
;-	fetch syscall-no. n by byte-counted name at a.
__CODE 3,'(s)',PSYSP
%if 1
	mov eax,@TOS
	test @TOS,@TOS
	__ENTER
	push edi		;save reg to PS
	push esi		;
	push byte 0		;prepare error flag
%assign p_US 8
	mov edx,syscalref-2	;names, ptr to pre-initial item stg posn <.byte 0,0 :<>: 0,0>
	mov ecx,[edx-10]	;no. of syscalls
	js .1
	jz .3
	add @TOS,byte 4;lea TS,4(TS),TS		// ;stg after leading 3 chars
.5:
	mov eax,[@TOS-4];-4(TS),eax	// ;count & leading 3 chars, 1st test
.1:
	dec ecx
	js .3			;?;ret name not found
	mov edi,edx		;list, ptr to stg
	movzx edx,byte[edx];bl (edx),edx	// ;stg countbyte
	lea edi,[4+edi+edx];,edi	// ;for 16bit no, countbyte, <nul>-terminator
	mov edx,edi		;save next stg
	scasd
	jnz .4			;?;not found or, "display all" mode
	movzx eax,al		;stg count
	sub eax,byte 3
	mov esi,@TOS
	js .5			;?;..(which shouldn't happen, shortest name is 3 chars)..
	jz .2			;?;done
	xchg eax,ecx
	repz cmpsb
	mov eax,ecx		;rst syscalls count
	jnz .5			;?;no match
.2:
	movzx ecx,byte[edx-2];bl -2(edx),ecx	// ; syscall number
	mov [esp],ecx
.3:
	pop @TOS
	pop esi
	pop edi
	__NEXT
.4:
	jr .1
;	test eax,eax
;	jns .1			;?;not found
;	cmp @TOS,eax
;	jnz .1			;?;not found
;	pushad
;;;;	movl (s_US+p_US)(esp),US	;;;
;	lea ecx,[1+edx]
;	movzx edx,byte[edx];bl (edx),edx
;	movl uSTDOUT(US),ebx
;	sys_write
;	leal uTEMP(US),ecx
;	movb $BL,(ecx)
;	movl $1,edx
;	sys_ write
;	popal
;	jmp 1b
%else
	lea ecx,[ebx+1]
	movzx ebx,byte[ebx]
	spush ecx	;	( u a
	rpush ebx	;			[ u
	spush		;	( xx u a ...
	_mov eax,0
	_mov ebx,4
	spush eax	;	( 4 0 u a ...
	call CSTG.c	;	( u2 a1 u a
; ebx:=len(u2), ecx:=text(a2)
	mov eax,TOS(3)	; a
	mov edx,TOS(2)	; u
	mov TOS(3),ecx	; a2	syscalls list
	mov TOS(2),ebx	; u2
	mov TOS(1),eax	; a	name
	mov ebx,edx	; u
; in: ebx: u2 tos{ ret a2 u1 a1 }
;out: ebx=ret ecx=flg tos{ . xx u3 a3 }
	call search
	inc ecx		; flg
	rpop ebx	; stg count
.j:
	jnz near SYSA	;?; name not found
	mov eax,TOS(3)	; a3
	cmp byte[eax-2],0
	jnz .j		;?; false data
	__ENTER
	movzx ebx,byte[eax-1];syscall no.
	lea PS,[PS+3*CELSZ]
	__NEXT
%endif
;-
;- ssc		( p n -- p er )					'SC'
;-	executes OS specific system call n, return value/error code in er,
;-	syscall parameters from table at p, p pointing to 1st item in list:
;-	lo addr	ebx	<= this is where p points to; may directly be taken from {sp@}.
;-		ecx
;-		edx
;-		esi
;-		edi
;-	hi addr	ebp	(w. 2.4.+ linux kernel)
;-
;-	example eForth access, all reg values but eax & sp@ are optional:
;-		( edi esi edx ecx ebx sp@ eax -- edi esi edx ecx ebx eax2 )
;-	where eax2 is result, replacing the passed syscall number from eax on entry.
;-	for instance, reading a directory entry (fd=file descriptor):
;-		{ fd pad 200 sp@ 141 syscall }
;-	or, <sleep> a while (10s):
;-		{ 0 10 sp@ dup sp@ 162 syscall drop }
;-	Further reading:
;-		Linux system calls documentation in manual pages section 2,
;-			ebx corresponds to 1st arg in man-pages description.
;-		asmutils "os_linux.inc" for syscall numbers vs names,
;-		http://home.snafu.de/phpr/lhpsyscal.html, some docs...
;-
__CODE 7,"ssc",SC
.n:	mov eax,ebx		; syscall no.
	__ENTER
	mov ebx,[esp]	; end of arguments list
	_push -13		;EACCES	; default ernum
	push ebp
	push edi
	push esi
	mov edi,ebx
	mov ebx,[ebx]
	mov ecx,[edi+4]
	mov edx,[edi+8]
	mov esi,[edi+12]
	mov ebp,[edi+20]	;%if __KERNEL__ >= 24
	mov edi,[edi+16]
	sys_generic
	pop esi
	pop edi
	pop ebp
	mov [esp],eax	; syscall return value/ernum
.r:
	pop ebx
	__NEXT
;-
;- Device dependent I/O
;-	

;-	
; - cnum		( a1 u a2 u2 -- n )
; -	find string(a1,u) in list at a2 of size u2,
; -	ret stg no. or, -1 if n1,n2 out of range.

;-
;- vt mode:
;subroutines!
; tos( n0 ret n1 ...  -- n0 n1 ... )
;kostet nerven, die bldsinnige festlegung der 4th-register, ndern...!?
vtmd:A;subroutine!
	mov ecx,control.md
	jr ztype
vtme:A;subroutine!
	mov ecx,control.se
ztype:A
.n:
	mov edx,ecx
	not ecx
.l:
	cmp byte[edx],1
	inc edx
	jnc .l
	add edx,ecx
	push @TOS
	not ecx
	sys_write [uref uPOUP]
	pop @TOS
	ret
;-	reverse video
__CODE 5,'vt-mr',VTMR
	mov ecx,control.mr
	jr ztype4
;-	reverse video off
__CODE 5,'co-27',CO27
	mov ecx,control.27;no-blink
	jr ztype4
;-	bright
__CODE 5,'vt-md',VTMD
	mov ecx,control.md
	jr ztype4
;-	half bright -> black on black
__CODE 5,'vt-so',VTSO
	mov ecx,control.so
	jr ztype4
;-	clear half/bright mode
__CODE 5,'vt-se',VTSE
	mov ecx,control.se
	jr ztype4
;-
;- ztype	( a -- )
;-	type <nul> terminated, un-counted string to out-channel
__CODE 5,'ztype',ZTYPE
	mov ecx,ebx
	spop
ztype4:
	__ENTER
	call ztype
	__NEXT
;vt, as above
;-	underline	(console: bold)
__CODE 5,'vt-us',VTUS
	mov ecx,control.us
	jr ztype4
;-	underline off
__CODE 5,'vt-ue',VTUE
	mov ecx,control.ue
	jr ztype4
;-	attributes off
__CODE 5,'vt-me',VTME
	mov ecx,control.me
	jr ztype4
;- rs		( -- )
;-	reset terminal, (re-)install G0/0 character set
__CODE 1,"rs",VTRS
	spush
	mov ecx,control.ris
	_mov ebx,0
	call ztype
	jr VTG0
;- g0		( n -- )
;-	activate G0, n-th charcter set, 0 <= n < 5
;-	{ 0 g0 } restores 'default character set', 1..4 selects.
__CODE 1,"g0",VTG0
	mov cx,'('<<8|SI
	call escp
	jmp EMIT
escpt:A
    db 0,'B0UK',0,0,0
escp:A
	_and ebx,7
	jz .r
	movzx ebx,byte[ebx+escpt];0,'B0UK',0,0,0
	test ebx,ebx
	jz .r
	shl ebx,24
	mov cl,ESC
	mov bh,ch
.r:
	mov bl,cl
	ret
;- sttys
;-	reset console to known state ("stty sane")
__CODE 1,'sttys',STTYS
	__ENTER
	call sttys
	__NEXT
sttys:A;<bye)
	pushad
	lea edx,[ttyst]
	sys_ioctl dword[uref uPKBP],TCSETS
	sys_ioctl STDIN,TCSETS
	popad
	ret
;- iomode	( -- )
;-	fcntl stdin to non-blocking & r/o, stdout to sync & w/o.
;-	NOTE:	channels opened w/ sys_dup (etc.) cannot be set to distinct 
;-		non/blocking mode, will be set to 'sync', as output channel.
__CODE 1,'iomode',IOMODE
	__ENTER
	pushad
	sys_fcntl [uref uPINP],F_SETFL,O_RDONLY|O_NONBLOCK
	sys_fcntl [uref uPOUP],F_SETFL,O_WRONLY|O_SYNC
	popad
	__NEXT
;-	
;- w4f		( fd -- )			(l4)
;-	wait until input pending to channel fd. limited to fd-s in range [0,31].
W4F:__CODE -2<<16,"w4f",nW4F
;- w4i		( -- )				(l4)
;-	wait until input pending if stdin is console - implicit by <key>
;-	limited to stdin channel identifiers (fd-s) in range [0,31].
;man 2: int  select(int n, fd_set *readfds, fd_set *writefds, fd_set *exceptfds, struct timeval *timeout);
__CODE  7,"w4i",W4I
	push ebx
	mov ebx,[uref uPINP]
nW4F:;__CODE 0, "wait4fd",nW4F; headerless, entrypoint for <wait4in>
	call w4f
	__ENTER
	pop ebx
	__NEXT
w4f:A
	_cmp ebx,32
	jnc .r
	push esi
	push edi
	mov ecx,ebx	; chan
	mov esi,esp
	movzx ebx,bh	; 0
	bts ebx,ecx	; in
	push ebx	; r/w/x flags
	mov ecx,esp	; ->readfds, also excep, write is NULL
	mov ebx,0x7fffffff; almost endless...
	push ebx	; timeval.sec
	push ebx
	mov edx,esp	; ->time
	push esi;;
	sys_select 32,EMPTY,NULL,ecx,edx
;differently(!) modified esp of calling job:
;	sys select edi,EMPTY,NULL,ecx,edx
;	sys select 32,EMPTY,ecx,ecx,edx
;	sys select 32,EMPTY,NULL,NULL,edx
;;	_add esp,3*4	<- doesn't help
	pop esp	;;
	pop edi
	pop esi
.r:
	ret
;
;- ?rx		( -- c T | F )
;-	Return input character & true, or false if no input.
__CODE 3, "?rx",QRX
	push ebx	; push @tos
.n:
	_push 0		; char
	mov ebx,[uref uPINP]
	__ENTER
	sys_read EMPTY,esp,1
	mov [uref uPEOFP],eax; save ernum, Z is <eof>, S is ernum, >0 is char(s) received
	neg eax		; -1 on success
	js .r		;?; char received
	_add esp,4	; drop buffer
	xor eax,eax
.r:
	mov ebx,eax
	__NEXT
;- tx!		( c -- )
;-	Send (max 32bit,min 8bit) character c to the output device.
__CODE 3, "tx!",TXSTO
	mov edx,ebx	; byte-cnt or zero
	bsr edx,ebx	; find top bit to send
	lea edx,[edx+7]	; round up to 8bit-byte size
	shr edx,3	; bytewise
	jnz .e		;?; non-zero cnt
	inc edx		; at least one byte
.e:
	__ENTER
	push    ebx
	mov ebx,[uref uPOUP]; to stdout
	sys_write EMPTY,esp
	pop eax		; pop the output buffer
	pop ebx
	__NEXT

;- !io		( -- )
;-	Initialize the serial I/O devices.
;-	set stdin to zero-timeout input. open a channel for keyboard input
__CODE 3, "!io",STOIO
	__ENTER
	call stoio
	__NEXT
kbopen:A
	pushad
	xor edx,edx
	mov ebx,[uref uPKBP]
	cmp ebx,edx
	jns vtini.r	;?; if already open set kbd mode
	mov ebx,ttyt
	sys_open EMPTY,O_RDWR
	mov [uref uPKBP],eax
	mov ebx,eax
	jr vtini.n
; -?- it might be required to re-opening stdout & stderr for independent sets of console-flags -?- ;
stoio:A
	call kbopen
vtini:A
	pushad
	mov ebx,[uref uPINP]
.n:
	mov ecx,O_RDWR|O_NONBLOCK
	sys_fcntl EMPTY,F_SETFL,ecx
.r:
	lea edx,[utattr]
	sys_ioctl EMPTY,TCGETS					; will be modified
	_and dword[byte edx+termios.c_lflag],~(ICANON|ECHO)	; leave sig's enabled, disable erase/fill processing, echo
	_or  dword[byte edx+termios.c_oflag],ONLCR;OPOST|ONLCR	; enable output processg, NL<-CR/NL
	_and dword[byte edx+termios.c_iflag],~(INPCK|ISTRIP|IXON); 8bit chars
	mov byte[byte edx+termios.c_cc+VTIME],1;qtermtimo	; timo * 1/10 s (if ~ICANON)
	mov byte[byte edx+termios.c_cc+VMIN],1 ;qtermnum	; min no. of chars for a single read opr
	sys_ioctl EMPTY,TCSETS					; set new tty mode
	popad
	ret
;- Initialize assembly variables uU0, _USER
%assign uU0   0
%assign _USER 4*CELSZ

;-
;- (ior)	( -- a )
;-	ptr to latest input error code, 0 is <eof>, -1...-4095 is ernum
__USER 5,"(ior)",PEOFP
;- argc   	( -- a )
;-	C main() argument argc, prg. name inclusive, i.e, 1 is no arguments!
__USER 4,"argc",CARGC
;- argv		( -- a )
;-	C main() argument argv, name at { argv @ argc 1- cells + @ }
__USER 4,"argv",CARGV
;- environ	( -- a )
;-	C environment strings
__USER 7, "environ",CENVIRON
;- bss		( -- a )
;-	C brk() address
;-	[hp,v1.2: former name "brk" - we do not "C", though...]
__USER 3, "bss",BSS

;-
;- ********************** The  OS-independent kernel *************************
;-

;-
;- <iuser>
;-	initiate user vari from defaults
__CODE 0,"iuser",IUSER	;[hp]
	mov UR,[up2]		; UR ref. reg
	push IP
	push UR
	lea UR,[uref UFIRST-UZERO]
	mov IP,UFIRST		; base addr of defaults
	_mov ecx,(ULAST-UFIRST)/4
	rep movsd
	pop UR
	pop IP
; minimal uvari reset for "cold"
__CODE 0,'cuser',CUSER
	spush
	__ENTER
	mov ecx,[dlastn]
	mov edx,[dctop]
	mov ebx,[dntop]
	mov [FORTH.v],ecx
	mov [uref uLAST],ecx
	mov [uref uNP],ebx
	mov ecx,[uref uS0]
	mov [uref uCP],edx
	mov PS,ecx
.t:
	mov eax,[dtib]
	_mov ebx,0
	mov [uref uPTIBP],eax
	rpush dword JCOLD
	__NEXT
;- preset	( -- )
;-	Reset data stack pointer & the terminal input buffer from defaults.
__CODE 1,"preset",PRESET; dummy header, other code can continue to here
	mov PS,[dsp0]
	__ENTER
	mov [uref uS0],PS
	jmp disp CUSER.t
;-
;- System & user variables
;-	

;- u0		( -- a )
;-	Pointer to bottom of (basic) user area.
__CODE 2,"u0",U0; was "up" ->[hp]-> which is running ptr to free uarea
	push @TOS
	__ENTER
	mov @TOS,[up2];lea @TOS,[uref uU0]
	__NEXT
;- @origin
__CODE 7,"@origin",FORIGIN
	__ENTER
	mov @TOS,[@TOS+origin]
	__NEXT

;- +origin	
__CODE 7,"+origin",PORIGIN
	__ENTER
	lea @TOS,[@TOS+origin]
	__NEXT

;- lit@orig					(c)
__CODE COMPO|1,'lit@orig',LFORG
	spush
	mov @TOS,[IP+4]
	mov @TOS,[@TOS+origin]
	_add IP,2*CELSZ
	__NEXT
;- dprompt
__CODE 0,'dprompt',dprompt4
	spush
	__ENTER
	mov @TOS,[dprompt]
	__NEXT
;- dovoc	( -- )				(c)
;-	Run time action of VOCABULARIES.
__CODE COMPO+5,"dovoc",DOVOC	; -20
	lea ecx,[IP+2*CELSZ]
	rpop IP
	mov [uref uCNTXT],ecx
	__NEXT

;- dovar	( -- a )			(c)
;-	Run time routine for VARIABLE & CREATE.
__CODE COMPO+5,"dovar",DOVAR
	push @TOS
	lea @TOS,[IP+CELSZ]
	rpop IP
	__NEXT
;- douser					(c)
;-	Run time routine for user variables.
__CODE COMPO+6,"douser",DOUSE
	push @TOS
	mov @TOS,[IP+CELSZ]
	rpop IP
	lea @TOS,[uref @TOS]
	__NEXT
;- ;does
__CODE COMPO+6,';does',SDOES
	mov eax,@TOS
	lea @TOS,[IP+CELSZ]
	mov IP,[PS]
	mov [PS],eax
	__NEXT
; dodoes	( -- )				(c)
__NCOLON COMPO+6,'dodoes',DDOES
	dd RFROM,LATEST,NAMET,ONEP,ALIGNED,CELLP,STORE,EXIT
;-   dolit	( -- w )			(c)
;-	Push an inline literal.
__CODE COMPO+5, "dolit",DOLIT
        push @TOS
	mov @TOS,[IP+CELSZ]
        _add IP,2*CELSZ
        __NEXT
;- docol	( a -- )			(c)
;-	Process colon list.
__CODE COMPO+6, "docol",DOLST
	_sub RS,CELSZ		; push current PC on forth return stack
	__ENTER
	mov [RS],IP
	pop IP			; new list address from RET address !
	__NEXT
;- next               ( -- )			(c)
;-	Run time code for the single (+ve!) index loop.
;	: next ( -- )
;	  r> r> dup if 1 - >r @ >r exit then drop cell+ >r
__CODE COMPO+4, "next",DONXT
	dec dword[RS]
	js .l1			; ?decrement below 0
        mov     IP,[IP+CELSZ]	; branch back
        __NEXT
.l1:
        _add     IP,2*CELSZ	; continue past the branch offset
	_add     RS,CELSZ	; pop the index
        __NEXT
; base!
__CODE 1,"base!",BASES
	mov [uref uBASE],@TOS
	__ENTER
	spop
	__NEXT
; handler!
__CODE 0,'hnd!',HANDLS
	mov [uref uHANDL],@TOS
	__ENTER
	spop
	__NEXT
; resolve	( a -- )
;	store "here" as destn of forward branch to addr a
__CODE 0,'resolve>',RESLTO; here swap !
	mov eax,[uref uCP]
	__ENTER
	mov [@TOS],eax
	spop
	__NEXT
; tmp@
__CODE 0,'tmp@',TEMPF
	spush
	__ENTER
	mov @TOS,[uref uTEMP]
	__NEXT
;- state0bra	( -- )				(c)
;-	Branch if interpreting.
__CODE COMPO+0, "state0bra",SZBRA
	cmp dword[uref uTEVAL],dword INTER
	jz BRAN
	_add IP,2*CELSZ
	__NEXT
;- 0branch    ( f -- )				(c)
;-	Branch if flag is zero.
__CODE COMPO+7, "0branch",ZBRA
	or @TOS,@TOS	; flag
	pop @TOS	; pop TOS
	jz BRAN		;?; branch
	_add IP,2*CELSZ	; Point IP to next cell
	__NEXT
;- branch     ( -- )				(c)
;-	Branch to an inline address.
__CODE COMPO+6, "branch",BRAN
	mov IP,[IP+CELSZ]
	__NEXT
;- -branch    ( f -- )				(c)
;-	Branch if flag is non-zero.
__CODE COMPO+7, "-branch",NZBRA;[hp]
	or  @TOS,@TOS
	pop @TOS
	jnz BRAN
	_add IP,2*CELSZ
	__NEXT
;- =branch    ( n1 n2 -- )			(c)
;-	Branch if n1 = n2.
__CODE COMPO+7, "=branch",EQBRA;[hp]
	cmp @TOS,[PS]
	pop ebx
	pop @TOS
	jz BRAN
	_add IP,2*CELSZ
	__NEXT
;- (loop)
__CODE COMPO+6,'(loop)',PLOOP
	mov ecx,@TOR
.n:;	;<+loop zero inc.)
	inc ecx		; loop index
	cmp ecx,TOR(1)
	mov @TOR,ecx	; index
	jz  PPLOOP.r
	mov IP,[IP+4]
	__NEXT
;
__CODE COMPO+7,'(+loop)',PPLOOP
	mov ecx,@TOR	; loop index
	test ebx,ebx	; increment
	lea ecx,[ecx+ebx]; +
; leaving 0 +loop for counted begin..again structure
	pop @TOS
	jz PLOOP.n	;?; inc by one if 0
	mov eax,TOR(1)
	mov @TOR,ecx	; index
	lea eax,[eax+0x80000000]
	lea ecx,[ecx+0x80000000]
	js .p		; -ve inc
	cmp ecx,eax
	jnc .r		; count not > limit
.b:A
	mov IP,[IP+4]
	__NEXT
.p:A
	cmp ecx,eax
	jnc .b
.r:
	_add IP,2*CELSZ	; continue after loop
	_add RS,2*CELSZ	; drop loop parm
	__NEXT
;- (do)
__CODE COMPO+4,'(do)',PDOP
	pop eax
	__ENTER
	rpush eax,ebx
	spop
	__NEXT
;- (-leave)
__CODE COMPO+8,'(-leave)',PMLEAVEP
	test ebx,ebx
	__ENTER
	spop
	jz .r
	mov eax,TOR(1)
	dec eax
	mov @TOR,eax
.r:
	__NEXT
;- @execute   ( a -- )
;-	Execute vector stored in address a; noop if zero.
__CODE 8,"@execute",ATEXE
	mov ecx,[@TOS]
        test ecx,ecx
	pop @TOS
	jz MEXIT.r
	jmp ecx
;- execute    ( ca -- )
;-	Execute the word at ca.
__CODE 7, "execute",EXECU
	mov eax,@TOS
	pop @TOS
	jmp eax
;- exit       ( -- )
;-	Terminate a colon definition.
__CODE 4, "exit",EXIT
.n:
	mov IP,[RS]     ; Pop return address
        _add RS,CELSZ	; Adjust RP
        __NEXT
;- -exit	( n -- )
;-	Terminate a colon definition.
__CODE 4, "-exit",MEXIT
	test ebx,ebx
	spop
	jnz EXIT.n
.r:
        __ENTER
        __NEXT
;- noop
;-	do nothing	
__CODE 4,"noop",NOOP
next1:
	__ENTER
	__NEXT
;- chars      ( n -- n )			(i)
;-	Multiply tos by char size in bytes (a noop).
CHARS:__CODE -2<<16|IMEDD+5,"chars",next1;[hp]
;- state@	( -- n )
;-	n= tf if compiling
__CODE 6,"state@",STATEF
	push @TOS
	__ENTER
	mov @TOS,[uref uTEVAL]
	sub @TOS,INTER
	jz .r
	_mov ebx,-1
.r:
	__NEXT
;-
;- Memory
;-

__CODE 0,"0,",ZCOMMA
	spush
	_mov ebx,0
	jr COMMA.n
;-   ,          ( w -- )
;-              Compile an integer into the code dictionary.
__CODE 1,",",COMMA
.n:	mov eax,[uref uCP]
	__ENTER
	mov [eax],@TOS
	_add eax,CELSZ
	pop @TOS
	mov [uref uCP],eax
	__NEXT
;- move			( from to count -- )
;-	move bytewise, non-overwriting
__CODE 5,"move",MOVE4
	mov eax,[esp]	; dst
	cmp eax,TOS(1)	; src
	jnc CMOVEU.n
;- cmove		( from to count -- )
;-	if count > 0 move bytewise, to ascending address
__CODE 0,"cmove",CMO
cmo:	mov ecx,@TOS	; count
	mov eax,IP	; save..
	mov @TOS,UR	;  ..regs
	pop edi		; dst
	pop esi		; src
	test ecx,ecx	;ans: count > 0
	jng .r
	rep movsb
.r:
	mov UR,@TOS	; rst..
	lea IP,[eax+CELSZ]; next wa
	pop @TOS
        __NEXT
CMOVE4:__CODE -2<<16|5,"cmove",cmo
;- cmove>		( from to count -- )
;-	move bytewise, to descending address
__CODE 5,"cmove>",CMOVEU
.n:
	mov ecx,@TOS	; count
	mov eax,IP	; save..
	mov @TOS,UR	;  ..regs
	pop edi		; dst
	pop esi		; src
	test ecx,ecx	;ans: count > 0
	jng .r
	lea edi,[edi+ecx-1]
	lea esi,[esi+ecx-1]
	std
	rep movsb
	cld
.r:
	mov UR,@TOS	; rst regs
	lea IP,[eax+CELSZ]; next wa
	pop @TOS
	__NEXT
;- fill			( b u c -- )
;-	Fill u bytes of character c to area beginning at b.
;FILL:__AWORD 0,"fill",fill
FILL:__CODE -2<<16,"fill",fill
;- erase		( b u c -- )
;-	erase (set to 0) u bytes at area beginning at b.
__CODE 5,"erase",ERASE
	push ebx
	_mov ebx,0
fill:;__CODE 0,"fill",fill
        mov eax,@TOS
        __ENTER
	mov @TOS,edi
        pop ecx
        pop edi
        rep stosb
	mov edi,@TOS
        pop @TOS
	__NEXT		;[hp] ret!
;- count      ( b -- b +n )
;-	Return count byte of a string & add 1 to byte address.
__CODE 5,"count",COUNT
	inc @TOS
	__ENTER
	push @TOS
	movzx @TOS,byte[@TOS-1]
	__NEXT
;- zcount      ( b -- b +n )
;-	Return count of a <nul> terminated, un-counted string.
__CODE 5,"zcount",ZCOUNT
	push @TOS
	mov ecx,ebx
	__ENTER
	not ecx
.l:
	cmp byte[ebx],1
	inc ebx
	jnc .l
	add ebx,ecx
	__NEXT
;- allot	( n -- )
;-	Allocate n bytes to the code dictionary.
__CODE 5,"allot",ALLOT
	add [uref uCP],@TOS
	__ENTER
	pop @TOS
	__NEXT
;- +!         ( n a -- )
;-	Add n to the contents at address a.
__CODE 2,"+!",PSTOR	; -24
	pop eax
	__ENTER
	add [ebx],eax
	pop ebx
	__NEXT
;- !          ( w a -- )
;-	Pop the data stack to memory.
__CODE 1, "!",STORE
	pop     dword [@TOS]
	__ENTER
	pop     @TOS
	__NEXT
;- off		( a -- )
;-	clear (store zero to) cell at a
__CODE 1, "off",OFF
	mov dword[@TOS],0
	__ENTER
	pop     @TOS
	__NEXT
;- @          ( a -- w )
;-	Push memory location to the data stack.
__CODE 1, "@",AT4
	__ENTER
	mov     @TOS,[@TOS]
	__NEXT
;- c!         ( c b -- )
;-	Pop the data stack to byte memory.
__CODE 2, "c!",CSTOR
	pop     eax
	__ENTER
	mov     [@TOS],al
	pop     @TOS
	__NEXT
;- c@         ( b -- c )
;-	Push byte memory location to the data stack.
__CODE 2, "c@",CAT
	__ENTER
	movzx   @TOS,byte [@TOS]
	__NEXT
;-
;- Stack
;-

;- pick		( wn...w0 +n -- wn...w0 wn )
;- pick		( wn...w0 w1 -n -- )
;-	Copy (+n)th stack item to tos; e.g. { 1 pick } = over, { 0 pick } = dup
;-	Copy w1 to (-n)th stack item.
__CODE 4,"pick",PICK	; -24
	test @TOS,@TOS
	__ENTER
	js .s
	mov @TOS,[PS+@TOS*4]
	__NEXT
.s:	neg @TOS
	mov ecx,TOS(1)
	js .r
	mov [PS+@TOS*4+4],ecx
	spop
.r:	spop
	__NEXT
;- aroll	( xx nn ..m.. mm +n adr -- xx ..m.. mm nn )
;-		( xx nn ..m.. mm -n adr -- xx mm nn ..m.. )
;-	roll within datafield the bottom address of which is at adr
__CODE 4,"aroll",AROLL
	mov eax,ebx
	spop
	jr ROLL.n
;- roll		( xx nn ..m.. mm +n -- xx ..m.. mm nn )
;-		( xx nn ..m.. mm -n -- xx mm nn ..m.. )
;-	roll cells on stack
;-	e.g. { 2 roll } = rot, { 1 roll } = { -1 roll } = swap
__CODE 4,"roll",ROLL; -44 (vs. hi-level, only +ve roll)
	__ENTER
	mov eax,PS	; data 'top', bottom up
.n:
	mov ecx,ebx
	call roll
	spop	; drop cells count
	__NEXT
roll:A; subroutine!
;in: ecx=count, eax=top of a pushing towards lower addr. stack data field
;out:exc=0, edx:=rolled item, eflags=?, other regs un-changed
	test ecx,ecx; count
	js .s		;?; roll bot. up
	jz .d		;?; nothing, drop index
	push edi
	push esi
	lea edi,[eax+ecx*4]	; (cmove>)
	lea esi,[edi-4]	; sp@ cell-
	mov edx,[edi]	; >rr pick r>
	std
	rep movsd	; move top down
	cld
	pop esi
	pop edi
	mov [eax],edx
.d:
	ret
.s:A; -ve
	push esi
	push edi
	neg ecx
	mov edi,eax
	mov edx,[eax]
	lea esi,[edi+4]
	rep movsd
	mov [edi],edx
	pop edi
	pop esi
	ret
;- rp@                ( -- a )
;-	Push the current RP to the data stack.
__CODE 3, "rp@",RPAT
	push    @TOS
	__ENTER
	mov     @TOS,RS
	__NEXT
;- rp!                ( a -- )
;-	Set the return stack pointer.
__CODE COMPO+3, "rp!",RPSTO
	mov     RS,@TOS
	__ENTER
	pop     @TOS
	__NEXT
;- r+!		( w -- )(R: w1 -- w2 )
;-	add cell from tos to @tor
__CODE 3,"r+!",RPLUSS
	add [RS],@TOS
	__ENTER
	spop
	__NEXT
;- >rr		( w -- w )(R: -- w )
;-	copy @tos to tor
__CODE 3,">rr",TORR
	sub RS,byte CELSZ
	__ENTER
	mov [RS],@TOS
	__NEXT
;- >r		( w -- )
;-	Push the data stack to the return stack.
__CODE 2, ">r",TOR
	sub RS,byte CELSZ
	__ENTER
	mov [RS],@TOS
	pop @TOS
	__NEXT
;- r>         ( -- w )
;-	Pop the return stack to the data stack.
__CODE 2, "r>",RFROM
	push @TOS
	mov @TOS,[RS]
.n:
	__ENTER
	add RS,byte CELSZ
	__NEXT
;- r>drop	( -- )
;-	drop from return stack.
__CODE 2, "r>drop",RDROP
	jr RFROM.n
;- j         ( -- w )
;-	Copy loop index (top of return stack) to the data stack.
__CODE 1, "j",J
	push @TOS
	__ENTER
	mov ebx,[RS+2*CELSZ]
	__NEXT
;- i         ( -- w )
;-	Copy loop index (top of return stack) to the data stack.
I:__CODE -2<<16|1,"i",rat

;- r@         ( -- w )
;-	Copy top of return stack to the data stack.
__CODE 2, "r@",RAT
rat:	push @TOS
	__ENTER
	mov @TOS,[RS]
	__NEXT
;- ni	( n -- w )
;-	fetch n-th level LOOP index. { 0 ni } is { i }.
__CODE 2, "ni",NI
	__ENTER
	mov @TOS,[RS+@TOS*2*CELSZ]
	__NEXT
;- nl	( n -- w )
;-	fetch n-th level LOOP limit, n = 0 for 1st level.
__CODE 2, "nl",NL
	__ENTER
	mov @TOS,[RS+@TOS*2*CELSZ+4]
	__NEXT
;- sp@                ( -- a )
;-	Push the current data stack pointer.
__CODE 3, "sp@",SPAT
	push @TOS
	__ENTER
	mov @TOS,PS
	__NEXT
;- sp!                ( a -- )
;-	Set the data stack pointer.
__CODE 3, "sp!",SPSTO
.nt:
	mov PS,@TOS
	__ENTER
	pop @TOS
	__NEXT
;- sp>
__CODE 3,'sp>',SPR
	mov @TOS,[uref uS0]
	jmp disp SPSTO.nt
;- swap       ( w1 w2 -- w2 w1 )
;-	Exchange top two stack items.
__CODE 4, "swap",SWAP
	mov eax,@TOS
	__ENTER
	mov @TOS,[PS]
	mov [PS],eax
	__NEXT
;- over       ( w1 w2 -- w1 w2 w1 )
;-	Copy second stack item to top.
__CODE 4, "over",OVER
	push @TOS
	__ENTER
	mov @TOS,[CELSZ+PS]
	__NEXT
;- drop		( w -- )
;-	Discard top stack item.
__CODE 4, "drop",DROP
drop:	__ENTER
	pop @TOS
	__NEXT
;- 0dup		( w -- w w | 0 )
;-	Dup tos if its is not zero.
__CODE 4,"0dup",ZDUP
	test @TOS,@TOS
	__ENTER
	jz DUP.n
	__NEXT
;- dup		( w -- w w )
;-	Duplicate the top stack item.
__CODE 3, "dup",DUP
	__ENTER
.n:
	push @TOS
	__NEXT
; dup@			( w -- w n )
;	push content of address w
__CODE 4,'dup@',DUPF
	push @TOS
	__ENTER
	mov @TOS,[@TOS]
	__NEXT
;- ?dup		( w -- w w | 0 )
;-	Dup tos if its is not zero.
__CODE 4,"?dup",QDUP
	test @TOS,@TOS
	__ENTER
	jnz DUP.n
	__NEXT
;- rot		( w1 w2 w3 -- w2 w3 w1 )
;-	Rot 3rd item to top.
__CODE 3,"rot",ROT
	mov ecx,@TOS	; 3
	__ENTER
	mov @TOS,[PS+4]	; 1->3
	mov eax,[PS]	; 2
.m:
	mov [PS+4],eax	; 2->3
	mov [PS],ecx	; 3->2
	__NEXT
;- -rot		( w1 w2 w3 -- w3 w1 w2 )
;-	Rot top item to 3rd.
__CODE 3,"-rot",MROT	; 1->2, 2->3, 3->1
	mov eax,@TOS	; 3->1
	__ENTER
	mov ecx,[PS+4]	;1
	mov @TOS,[PS]	;3<-2
	jmp disp ROT.m
;-
;- bit op.
;-

;- not		( w1 -- w2 )
;-	bitwise invert w, w2 := 1s-cpl of w1
__CODE 3,"not",INVER		;[hp]
	__ENTER
	not @TOS
	__NEXT
		
;- and		( w w -- w )
;-	Bitwise AND.
__CODE 3, "and",ANDD
	pop eax
	__ENTER
	and @TOS,eax
	__NEXT
;- or         ( w w -- w )
;-	Bitwise OR.
__CODE 2, "or",ORR
	pop eax
	__ENTER
	or @TOS,eax
	__NEXT
;- xor		( w w -- w )
;-	Bitwise exclusive OR.
__CODE 3, "xor",XORR
	pop eax
	__ENTER
	xor @TOS,eax
	__NEXT
;-
;- Logic
;-

;- 0>         ( n -- t )
;-	Return true if n is positive non-zero.
__CODE 2, "0>",ZGREAT
	dec @TOS
	sar @TOS,31
	__ENTER
	not @TOS
	__NEXT
;- 0<         ( n -- t )
;-	Return true if n is negative.
__CODE 2, "0<",ZLESS
	__ENTER
	sar @TOS,31
	__NEXT

;-
;- Arithetic
;-

;- 1+		( a -- a )
;-	Add cell size in byte to address.
__CODE 2,"1+",ONEP		;[hp]
	__ENTER
	inc @TOS
	__NEXT

;- 1-		( a -- a )
;-	Subtract cell size in byte from address.
__CODE 2,"1-",ONEM		;[hp]
	__ENTER
	dec @TOS
	__NEXT
;- 4+
P4:__CODE -2<<16|2,'cell+',cellp
;- cell+	( a -- a )
;-	Add cell size in byte to address.
__CODE 5,"4+",CELLP
cellp:	__ENTER
	add @TOS,byte CELSZ
	__NEXT
;- 4-
M4:__CODE -2<<16|5,'cell-',cellm
;- cell-	( a -- a )
;-	Subtract cell size in byte from address.
__CODE 2,"4-",CELLM
cellm:	__ENTER
	sub @TOS,byte CELSZ
	__NEXT
;- cells	( n -- n )
;-	Multiply tos by cell size in bytes.
L4:__CODE -2<<16|5,"cells",cells
;- 4*		( n -- n )
;-	Multiply tos by 4.
__CODE 2,"4*",CELLS
cells:	__ENTER
	shl @TOS,2
	__NEXT
;- negate	( n -- -n )
;-	Two-s complement of tos.
__CODE 6,"negate",NEGAT		;[hp]
	__ENTER
	neg @TOS
	__NEXT

;- -		( n1 n2 -- n1-n2 )
;-	Subtraction.
__CODE 1,"-",SUBB		;[hp]
	sub [PS],@TOS
	__ENTER
	pop @TOS
	__NEXT
;- x-		( n1 n2 -- n2-n1 )
;-	reverse subtraction
__CODE 1,'x-',XSUBB		;[hp]
	sub @TOS,TOS(1)
	__ENTER
	lea PS,[PS+CELSZ]
	__NEXT
;- 0=         ( n -- t )
;-	Return true if n is zero.
__CODE 2, "0=",ZEQ		;[hp]
	cmp @TOS,byte 1
	__ENTER
	sbb @TOS,@TOS
	__NEXT

;- flag		( n -- f )
;-	f = tf if n =/= 0, else ff; "0=/="
__CODE 4,"flag",FLAG
	test ebx,ebx
	__ENTER
	mov ebx,0	; nicht _mov (flags!)
	jz .r
	dec ebx
.r:
	__NEXT
;- +		( w w -- sum )
;-	Add top two items.
__CODE 1,"+",PLUS
	pop eax
	__ENTER
	add @TOS,eax
	__NEXT
;- =		( w w -- t )
;-	Return true if top two are equal.
__CODE 1,"=",EQUAL
	pop eax
	__ENTER
	cmp @TOS,eax
	mov @TOS,0
	jnz .r
	dec @TOS
.r:
	__NEXT

;- <		( n1 n2 -- t )
;-	Signed compare of top two items.
__CODE 1,"<",LESS
	pop eax
	__ENTER
	cmp eax,@TOS
	mov @TOS,0	
	jge sfalse
	dec @TOS	
sfalse:
	__NEXT

;- >		( n1 n2 -- t )
;-	Signed compare of top two items.
__CODE 1,">",GREAT
	pop     eax
	__ENTER
	cmp eax,@TOS
	mov @TOS,0	
	jle sfalse
	dec @TOS
	__NEXT
;- 2*		( n1 -- n2 )
;-	Signed multiply by 2
__CODE 1,"2*",STAR2
	__ENTER
	shl @TOS,1
	__NEXT

;- 2/		( n1 -- n2 )
;-	Signed divide by 2
__CODE 1,"2/",BY2
	__ENTER
	sar @TOS,1
	__NEXT
;- 4/		( n1 -- n2 )
;-	Signed divide by 4
__CODE 1,"4/",BY4
	__ENTER
	sar @TOS,2
	__NEXT

;- shift	( n1 n -- n3 )
;-	shift n1 by n2 bits, unsigned right w/ -n, left w. +n
__CODE 5,'shift',SHIFT
	mov ecx,ebx
	test ebx,ebx
	__ENTER
	pop @TOS
	js .r
	shl @TOS,cl
	__NEXT
.r:
	neg ecx
	shr @TOS,cl
	__NEXT
;- 1abs		( n -- -n-1 )
;-	1s-cpl absolute value.
;-	can be used to testing whether a double fits into a sing.
__CODE 3,"1abs",OABS
	cmp @TOS,byte 0
	__ENTER
	jns .r
	not @TOS
.r:
	__NEXT
;- abs		( n -- n )
;-	Return the absolute value of n.
__CODE 3,"abs",ABSS
	neg @TOS
	__ENTER
	jns .r
	neg @TOS
.r:
	__NEXT
;- u<		( u u -- t )
;-	Unsigned compare of top two items.
__CODE 2,"u<",ULESS
	pop eax
	__ENTER
	cmp eax,@TOS
	mov @TOS,0
	jnc .r
	dec @TOS
.r:
	__NEXT
;- over-	( w1 w2 -- w1 w3 )
;-	subtract @nos from @tos.
__CODE 5, "over-",OVERM	;[hp]
	__ENTER
	sub @TOS,[PS]
	__NEXT
;- bounds-	( w1 n -- w2 w1 )
;-	ret w2 w1 sutable for a do/loop of n1 passes baginning at w1 - { over + swap }
__CODE 5, "bounds",BOUNDS;[hp]
	__ENTER
	xadd [PS],@TOS
	__NEXT
;- max		( n n -- n )
;-	Return the greater of two top stack items.
__CODE 3,"max",MAX
	pop eax
	__ENTER
	cmp @TOS,eax
	jnl .r
	mov @TOS,eax
.r:
	__NEXT
;- min		( n n -- n )
;-	Return the smaller of top two stack items.
__CODE 3,"min",MIN
	pop eax
	__ENTER
	cmp @TOS,eax
	jng .r
	mov @TOS,eax
.r:
	__NEXT
;- within	( u ul uh -- t )
;-	Return true if u is within the range of ul & uh. ( ul <= u < uh )
; over - >r - r> u< ;
__CODE 6,"within",WITHIN
	pop eax	; ul	;n2
	pop ecx	; u	;n1
	sub ebx,eax	; uh ul -
	sub ecx,eax	; u  ul -
	__ENTER
	cmp ecx,ebx	; (u-ul)|(uh-ul)
	mov ebx,-1
	jc .r
	inc ebx
.r:
	__NEXT
;- *		( n n -- n )
;-	Signed multiply. Return single product.
__CODE 1,"*",STAR
	pop eax
	__ENTER
	mul @TOS
	mov @TOS,eax
	__NEXT
;-
;- Divide
;-
;-	Signed divide. Return mod & quotient
;-	dft "round near zero" mode, via sm/rem
;-

;-	

;- /mod		( n1 n2 -- r q )		(v)
;-	Signed divide. Return mod & quotient - floored, via "'m/mod"
__CODE 4,"/mod",SLMOD
	mov ecx,[PS]
	sar ecx,31
	spush ecx
	jmp dword[uref uTMBYM]
;- */mod	( n1 n2 n3 -- r q )
;-	Multiply n1 & n2, then divide by n3. Return mod and quotient.
__CODE 5,"*/mod",SSMOD
	mov eax,[PS+4]
	imul dword[PS]
	mov [PS+4],eax
	mov [PS],edx
	jmp dword[uref uTMBYM]
;- */		( n1 n2 n3 -- q )
;-	Multiply n1 by n2, then divide by n3. Return quotient only.
__CODE 2,"*/",STASL
	dd SSMOD,SDROP,EXIT
;- mod		( n n -- r )
;-	Signed divide. Return mod only. - floored
__COLON 3,"mod",MODD
	dd SLMOD,DROP,EXIT
;- /		( n n -- q )
;-	Signed divide. Return quotient only.
__COLON 1,"/",SLASH
	dd SLMOD,SDROP,EXIT
;-
;- Doubles
;-

;-

;- s>d		( n -- dn )
;-	sign extend sing to double.
__CODE 3, "s>d",STOD		;[hp]
	push @TOS
	__ENTER
	sar @TOS,31
	__NEXT
;- s>u		( n -- dn )
;-	unsigned extend sing to double.
__CODE 3, "s>u",STOU		;[hp]
	push @TOS
	__ENTER
	_mov ebx,0
	__NEXT
;- d>s		( dn -- n )
;-	truncate double to sing.
DTOS:__CODE -2<<16|3, "d>s",drop;[hp]
;- 2swap	( d1 d2 -- d2 d1 )
;-	Exchange top two stack doubles.
__CODE 4, "2swap",SWAP2
	mov eax,@TOS	; d2h
	mov edx,TOS(3)	; d1l
	mov @TOS,TOS(2)	; d1h
	mov ecx,TOS(1)	; d2l
	__ENTER
	mov TOS(1),edx	; d1l
	mov TOS(2),eax	; d2h
	mov TOS(3),ecx	; d2l
	__NEXT
;- 2over	( d1 d2 -- d1 d2 d1 )
;-	Copy second stack double to top.
__CODE 4, "2over",OVER2
	push @TOS
	__ENTER
	push dword TOS(4)
	mov @TOS,TOS(4)
	__NEXT
;- 2!		( d a -- )
;-	Store double to address a.
__CODE 2,"2!",DSTOR	; -16
	pop eax
	pop edx
	__ENTER
	mov [ebx],eax
	mov [ebx+CELSZ],edx
	pop ebx
	__NEXT
;- 2@		( a -- d )
;-	Fetch double from address a.
	__CODE 2,"2@",DAT	; -20
	mov ecx,[@TOS+CELSZ]
	__ENTER
	push ecx
	mov ebx,[ebx]
	__NEXT
;- 2r@		( -- d )
;-	Fetch double from RP.
__CODE 3, "2r@",DRPAT
	push    @TOS
	__ENTER
	push dword[RS]
	mov @TOS,[RS+4]
	__NEXT
;- 2drop	( w w -- )
;-	Discard two items on stack.
__CODE 5,"2drop",DDROP
	__ENTER
	pop @TOS
	pop @TOS
	__NEXT
;- 2dup		( w1 w2 -- w1 w2 w1 w2 )
;-	Duplicate top two items.
__CODE 4,"2dup",DDUP
	mov eax,[PS]
	__ENTER
	push @TOS
	push eax
	__NEXT
;-
;- -------------
;-

;- 4dup		( w1 w2 -- w1 w2 w1 w2 )
;-	Duplicate top two items.
__CODE 4, "4dup",DUP4
	push @TOS
	__ENTER
	push dword TOS(4)
	push dword TOS(4)
	push dword TOS(4)
	mov @TOS,TOS(4)
	__NEXT
;- ndrop  	( n -- )
;-	Discard n stack cells (-ve n reserves space on stack).
__CODE 4, "ndrop",NDROP
	__ENTER
	lea PS,[PS+@TOS*4]
	spop
	__NEXT
;- sdrop	( n1 n2 -- n2 )
;-	drop @nos
__CODE 4,"sdrop",SDROP
	__ENTER
	lea PS,[PS+4]
	__NEXT
;-
;- -------------
;-

;-

;- um+		( u u -- udsum )
;-	Add two unsigned single numbers, return a double sum.
__CODE 3, "um+",UPLUS
	add [PS],@TOS
	__ENTER
	mov @TOS,0 
	adc @TOS,@TOS
	__NEXT
;- m+		( dn1 n2 -- dn3 )
;-	signed add n2 + dn1 := dn3
; c: ecx
__CODE 1,'m+',MPLUS
	spush
	sar @TOS,31
	jr DPLUS
;- d1+		( dn1 -- dn2 )
__CODE 1,'d1+',DONEP
	spush
	_mov ecx,1
	_mov edx,0
	jr DPLUS.1
;- d+		( dn1 dn2 -- dn3 )
;-	add doubles
__CODE 1,'d+',DPLUS
	spop ecx	;d2.l
	mov edx,@TOS	;d2.h
.1:	__ENTER
	spop		;d1.h
	add [PS],ecx
	adc @TOS,edx
	__NEXT
;- d-  		( dn1 dn2 -- dn3 )
;-	subtract doubles
__CODE 1,'d-',DSUBB
	spop ecx	;d2.l
	mov edx,@TOS	;d2.h
	__ENTER
	spop
	sub [PS],ecx	; 1l-2l
	sbb @TOS,edx	; 1h-2h-c
	__NEXT
;- dnegate	( d -- -d )
;-	Two-s complement of top double.
__CODE 1,"dnegate",DNEGA
	neg dword[PS]
	__ENTER
	adc @TOS,byte 0
	neg @TOS
	__NEXT
;-
;- 2shift	( d1 n -- d2 )
;-	shift d1 by n bits, unsigned right w/ -n, left w. +n
__CODE 5,'2shift',DSHIFT
	test ebx,ebx
	__ENTER
	js .m
	jz .x
	mov cl,bl
	mov ch,bl
	spop
	sub ch,32
	js .s
	mov ebx,TOS(1)
	mov dword TOS(1),0
	jz .x
	mov cl,ch
.s:
	mov edx,TOS(1)
	shld ebx,edx,cl
	shl edx,cl
	mov TOS(1),edx
.x:
	__NEXT
.m:A
	neg ebx
	mov cl,bl
	mov ch,bl
	spop
	sub ch,32
	js .r
	mov TOS(1),ebx
	mov ebx,0
	jz .x
	mov cl,ch
.r:
	shrd dword TOS(1),ebx,cl
	shr ebx,cl
	__NEXT
;-
;- -------------
;-

;- um*		( u u -- ud )
;-	Unsigned multiply. Return double product.
__CODE 3,"um*",UMSTA
	mov eax,@TOS
	__ENTER
	mul dword[PS]
	mov [PS],eax
	mov @TOS,edx
	__NEXT
;- umdm*	( ud1 u -- ud2 ovf )
;-	unsigned multiply double by sing, leave double & overflow sing
__CODE 2,"umdm*",UMDMMUL
	mov ecx,@TOS	; u2
	spop ebx	; d1.h
	spop eax	; d1.l
	mul ecx		; a:=mll d:=mlh
	spush eax	; ->p.l
	mov eax,ebx	; a:=d1h
	__ENTER
	mov ebx,edx	; b:=mlh
	mul ecx		; a:=mhl d:=mhh
	add ebx,eax	; a:=p.h
	spush		; ->p.h
	mov ebx,edx	; ovf
	__NEXT
;- m*		( n n -- d )
;-	Signed multiply. Return double product.
__CODE 2,"m*",MSTAR
	mov eax,@TOS
	__ENTER
	imul dword[PS]
	mov [PS],eax
	mov @TOS,edx
	__NEXT
;- m/mod	( d n -- r q )			(v)
;-	via user vector "'m/mod", default is "sm/rem"
__CODE 5,"m/mod",MBYM
	jmp dword[uref uTMBYM]
;-
;- sm/rem	( d n -- r q )
;-	Signed 'round near zero' divide of double by single. Return mod & quotient.
;-	div by zero: ret max(sgn(dividend)), ret (1,0) if dividend = 0
;-	if quot would overflow ret unchanged dividend, for further processing.
__CODE 6,"sm/rem",SMBYR
	pop edx		; ddh
	pop eax		; ddl
	__ENTER
    %ifndef fpe_sig
	test @TOS,@TOS	; dvs
	mov ecx,@TOS	;		; dup 0< dup >r
	jz RDZ		;?; div0
	cmp @TOS,edx
	jc RDO		;?; ovf
	idiv @TOS
	test ecx,ecx
	jns .m3
	neg edx
.m3:
	mov @TOS,eax
	push edx
	__NEXT
RDZ:A	; ret from div by zero
	or @TOS,edx
	or @TOS,eax
	jz .o		;?; 0 / 0 = 1
	sar edx,31
	lea @TOS,[edx*2+0x80000001]
	neg @TOS
	push @TOS
	__NEXT
.o:A
	push @TOS
	inc @TOS
	__NEXT
RDO:A	; ret dividend from div ovf
	push eax
	mov @TOS,edx
	__NEXT
    %else
	call .i
	mov @TOS,eax
	push edx
	__NEXT
.i:A
	idiv @TOS
	ret
    %endif
;- um/mod	( udl udh un -- ur uq )
;-	Unsigned divide of a double by a single. Return mod & quotient.
;-	div by zero: ret max(sgn(dividend)), ret (1,0) if dividend = 0
;-	if quot would overflow ret unchanged dividend, for further processing
__CODE 6,"um/mod",UMMOD
	pop edx		; ddh
	pop eax		; ddl
	__ENTER
    %ifndef fpe_sig
	test @TOS,@TOS	; dvs
	jz RDZ		;?; div0
	cmp @TOS,edx
	jc RDO		;?; ovf
	div @TOS
    %else
	%if 1
	push dword UMMOD.r
	mov ecx,ebx
	div ecx
	_add esp,4
	%else
	call cdiv
	%endif
    %endif
.x:
	push edx
	mov @TOS,eax
	__NEXT
    %ifdef fpe_sig
.r:A
	or ecx,eax
	or ecx,edx
	mov eax,-1
	mov edx,eax
	jnz .x
	neg eax
	not edx
	jr .x
    %endif
cdiv:A
	div @TOS
	ret
;- fm/mod	( d n -- r q )
;-	Signed floored divide of double by single. Return mod & quotient.
;-	div by zero: ret max(sgn(dividend)), ret (1,0) if dividend = 0
;-	if quot would overflow ret unchanged dividend, for further processing
__CODE 6,"fm/mod",FMBYM		; was"m/mod"
	pop edx		; ddh
	pop eax		; ddl
	__ENTER
    %ifndef fpe_sig
	test @TOS,@TOS	; dvs
	mov ecx,@TOS	;		; dup 0< dup >r
	jz RDZ		;?; div0
    %else
	mov ecx,@TOS	;		; dup 0< dup >r
    %endif
	jns .m1		;		; if
	neg @TOS	;		; negate >r dnegate r> endif
	neg eax
	adc edx,0
	neg edx
.m1:
	test edx,edx
	jns .m2
	add edx,@TOS
.m2:
    %ifdef fpe_sig
	call cdiv
    %else
	div @TOS
    %endif
	test ecx,ecx
	jg .m3
	jnz .n
	test edx,edx
	jz .n
	neg eax
.n:
	neg edx
.m3:
	mov @TOS,eax
	push edx
	__NEXT
;-
;- Numeric input, single precision
;-

;- digit	( u -- c )
;-	Convert digit u to a character.
__CODE 5,"digit",DIGIT
	cmp byte[uref uBASE+1],0
	__ENTER
	jnz .r		;?; cannot convert or, base is ascii/utf
	movzx @TOS,bl
.e:
	cmp bl,10
	jc .n
	add bl,7
.n:
	add bl,'0'
.r:
	__NEXT
;- (#)		( n base -- n c )
;-	Extract the least significant digit from n.
__CODE 7,"(#)",EXTRC
	mov eax,[PS]
	_mov edx,0
	mov ecx,ebx
	cmp edx,ebx
	movzx ebx,al
	jz DIGIT.r
	div ecx
	__ENTER
	mov ebx,edx
	mov [PS],eax
	jmp disp DIGIT.e
;- <#		( -- )
;-	Initiate the numeric output process.
__CODE 2,"<#",BDIGS
	mov ecx,[uref uCP]
	_add ecx,NPAD
	__ENTER
	mov [uref uHLD],ecx
	__NEXT
;- sign		( n -- )
;-	Add a minus sign to the numeric output string.
__CODE 4,"sign",SIGN
	test ebx,ebx
	jns disp DROP
	_mov ebx,'-'
	jr HOLD
;- hold		( c -- )
;-	Insert a character into the numeric output string.
__CODE 4,"hold",HOLD	; -24
	mov ecx,[uref uHLD]
	dec ecx
	__ENTER
	mov [uref uHLD],ecx
	mov [ecx],bl
	spop
	__NEXT
;- #		( u -- u )
;-	Extract one digit from u & append the digit to output string.
__COLON 1,"#",DIG
	dd BASEF,EXTRC,HOLD,EXIT
;- #s		( u -- 0 )
;-	Convert sing u until all digits are added to the output string.
	__COLON 2,"#s",DIGS
DIGS1:	dd DIG,DUP
	dd ZBRA,DIGS2
	dd BRAN,DIGS1
DIGS2:	dd EXIT
;- #>		( w -- b u )
;-	Prepare the output string to be "type"-d.
__CODE 2,"#>",EDIGS	; -12
	mov ebx,[uref uHLD]
	__ENTER
	spush
	neg ebx
	add ebx,[uref uCP]
	_add ebx,NPAD
	__NEXT
;- str		( w -- b u )
;-	Convert a signed integer to a numeric string.
__COLON 3,"str",STR4
	dd DUP,TOR,ABSS
	dd BDIGS,DIGS,RFROM
	dd SIGN,EDIGS,EXIT
;- hex		( -- )
;-	Use radix 16 as base for numeric conversions.
__CODE 3,"hex",HEX	; -16
	__ENTER
	_mov dword[uref uBASE],16
	__NEXT
;- decimal	( -- )
;-	Use radix 10 as base for numeric conversions.
__CODE 7,"decimal",DECIM; -16
	__ENTER
	_mov dword[uref uBASE],10
	__NEXT
;- [t]		( b u -- )
;-	dft word for 'type user vector, output u characters from b.
__CODE 4,"[t]",TYPEC
	mov edx,@TOS
	__ENTER
	pop ecx
	sys_write [uref uPOUP]
	pop @TOS
	__NEXT
;-
;- Miscellaneous
;-

;-
; user-deferred
;-
;- emit		( c -- )
;-	run xec-vec 'emit, send a character to the output device.
__CODE 4,"emit",EMIT
	jmp dword[uref uTEMIT]
;- space	( -- )
;-	Send the blank character to the output device.
__CODE 5,"space",SPACE	; -8
	spush
	_mov ebx,BL
	jmp disp EMIT
;- cr		( -- )
;-	Output a carriage return & a line feed.
__CODE 2,"cr",CRR	; -8
	spush
	_mov ebx,LF
	jmp disp EMIT
;;- pace		( -- )
;;-	Send a pace character for the file downloading process.
;;-	NOTE: eforth's "pace" is code 11, ascii <vt>.
;__CODE 4,"pace",PACE	; -8
;	spush
;	_mov ebx,11
;	jmp disp EMIT
; headerless, stg to number 
__CODE 0,'number',NUMBER
	jmp dword[uref uTNUMB]
;- echo		( c -- )
;-	run xec-vec 'echo, console "emit"
__CODE 1,'echo',XECHO
	jmp dword[uref uTECHO]
;- type		( a u -- )
;-	run xec-vec 'type, display count u chars of string at a.
__CODE 4,"type",TYPES
	jmp dword[uref uTTYPE]
;- print	( a -- )
;-	display counted string from a.
__CODE 1,'ctype',CTYPES
	movzx ecx,byte[ebx]
	inc ebx
	spush
	mov ebx,ecx
	jmp disp TYPES
;- ?key		( -- c T | F )
;-	Return input character & true, or a false if no input.
__CODE 4,"?key",QKEY
	jmp dword[uref uTQKEY]
;- -trailing	( b u -- b u )
;-	Adjust the count to eliminate trailing white space.
__CODE 9,"-trailing",DTRAI
	mov edx,[PS]
	__ENTER
	std
	push UR
	mov al,' '
	mov ecx,@TOS
	lea UR,[@TOS+edx]
	repz scasb
	sub edx,UR
	pop UR
	mov @TOS,edx
	pop edx
	cld
	__NEXT
;- latest	( -- a )
;-	name address of last word in current voc.
;-	valid immediately after a named definition.
__CODE 6,"latest",LATEST
	push @TOS
	__ENTER
	mov @TOS,[uref uCRRNT]
	mov @TOS,[@TOS]
	__NEXT
;- aligned	( b -- a )
;-	Align address to the cell boundary.
__CODE 7,"aligned",ALIGNED
	_add @TOS,(CELSZ-1)
	__ENTER
	_and @TOS,(-CELSZ)
	__NEXT
;- paligned	( b -- a )
;-	Align address to Linux PAGE_SIZE boundary.
__CODE 7,"paligned",PALGND;
	_add @TOS,PAGE_SIZE-1
	__ENTER
	_and @TOS,(-PAGE_SIZE)
	__NEXT
;- unused	( -- n )
;-	cells free in compile-space
__CODE 2,"unused",UNUSED
	push @TOS
	__ENTER
	mov @TOS,[uref uBSS]
	sub @TOS,[uref uCP]
	_sub @TOS,NPAD
	sar @TOS,CELLX
	__NEXT

;- depth	( -- n )
;-	Return the depth of the data stack.
__CODE 5,"depth",DEPTH	; -24
	spush
	__ENTER
	mov @TOS,[uref uS0]
	sub @TOS,PS
	sar @TOS,2
	__NEXT
;- here		( -- a )
;-	Return the top of the code dictionary.
__CODE 4,"here",HERE	; -8
	push ebx
	__ENTER
	mov ebx,[uref uCP]
	__NEXT
__CODE IMEDD+5,"begin",BEGIN; -12
	jmp disp HERE
;- pad		( -- a )
;-	Return the address of the text buffer above the code dictionary.
__CODE 3,"pad",PAD;	-12
	push ebx
	__ENTER
	mov ebx,[uref uCP]
	_add ebx,NPAD
	__NEXT
;- tib		( -- a )
;-	Return the address of the terminal input buffer.
__CODE 3,"tib",TIB; -8
	push ebx
	__ENTER
	mov ebx,[uref uPTIBP]
	__NEXT
;- name>	( na -- ca )
;-	Return code address given a name address.
;-	NOTE: ca at call to "dolist" or beginning of primitive code.
__CODE 5,"name>",NAMET	; -12
	__ENTER
	mov ebx,[ebx-2*CELSZ]
	__NEXT
;- pfa		( ca -- pa )
;-	ret parameter field address, from code address.
__CODE 1,'pfa',PFA
	_add ebx,(1+2*CELSZ)
	__ENTER		; 9 + aligned
	_and ebx,(-CELSZ)
	__NEXT
;- ?forth	( a -- f )
;-	tf if address a is in range of kernel + compile-space
__CODE 6,'?forth',Q4TH
	__ENTER
	call mrange
	__NEXT
mrange:A; ret: ecx:=@TOS, ebx:=flag
	mov ecx,ebx
	_mov ebx,-2
	cmp ecx,Y
	jc .f		;?; below kernel
	cmp ecx,[uref uBSS]
	jc .x		;?; compile-space
	cmp ecx,[uref uNP]
	jc .f		;?; below name-space
	cmp ecx,[dtib]; initial s0
	jc .x		;?; not above PS or, local compile-space (n.i.)
.f:
	inc ebx
.x:
	inc ebx
	ret
;- >char	( c1 -- c2 )
;-	Filter non-printing (long) characters.
__CODE 5,">char",TCHAR
	mov eax,ebx	; byte-cnt or zero
	__ENTER
	bsr eax,ebx	; find top bit to send
	lea eax,[eax+7]	; round up to 8bit-byte size
	shr eax,3	; bytewise
	jnz .e		;?; non-zero cnt
	inc eax		; at least one byte
.e:
	lea ecx,[eax*8]
.o:
	mov edx,pchmask
.c:
	cmp bl,dl
	jb .n		;?; invalid below lower bound
	cmp bl,dh
	jbe .s		;?; valid at & below upper bound
.l:
	shr edx,16
	jnz .c		;?; try 2nd range
.n:
	mov bl,'_'	; not a valid char, force NZ, C already cleared
.s:
	ror ebx,8
	dec eax
	jg .o
	rol ebx,cl
	__NEXT
;- key>char	( c -- c f )
;-	tf if c is printing char, c unchanged
__CODE 4,"key>char",K2C
	movzx ecx,bl
	__ENTER
	mov edx,pchmask
	_mov ebx,-1
.c:
	cmp cl,dl
	jb .n		;?; invalid below lower bound
	cmp cl,dh
	jbe .s		;?; valid at & below upper bound
.l:
	shr edx,16
	jnz .c		;?; try 2nd range
.n:
	inc ebx
.s:
	push ecx
	__NEXT
;;- ktap		( bot eot cur c -- bot eot cur | bot cur cur)
;;-	Process a control-key, CR or backspace.
__CODE 0,"ktap",KTAP	; -32
	_cmp ebx,LF		; dup <lf> =/=
	jz .2			; if
	_cmp ebx,DEL		;  <del> =/=
	jz .1			;  if
	mov ebx,BL		;   <bl>
	jr TAP
.1:A				;  endif
	spop			;  drop bs ;s
	jmp BKSP
.2:A				; endif
	mov ecx,[PS]		; emit swap drop dup ;s
	mov [PS+CELSZ],ecx
	jmp disp EMIT
;;- tap		( bot eot cur c -- bot eot cur )
;;-	Accept & echo the key stroke & bump the cursor. dft vector 'tap.
;;-	{ over c! 1+ }
__CODE 0,"tap",TAP
	pop ecx
	__ENTER
	mov byte[ecx],bl
	lea ebx,[ecx+1]
	__NEXT
;- esc?		( -- flag )
;-	if ?key returned <bl> wait until next <bl>
;-	ret tf if ?key was <esc> & no <bl>, else ff
__CODE 4,'esc?',ESCQ;-180
	push @TOS
	__ENTER
	call qrx
	jz .r
	_sub ebx,ESC
	jz .x
	_sub ebx,{' '-ESC}
	jnz .z
.k:
	call KEY.n
	_sub ebx,' '
	jnz .k
.z:
	mov ebx,-1
.x:
	not ebx
.r:
	__NEXT
;- key		( -- c )
;-	Wait for & return an input character.
__CODE 3,"key",KEY
	push @TOS
	__NEXT1	;push dword next1; enter & ret from lo-level word
.n:
	mov ebx,[uref uPINP]
	call w4f
; ?terminal ( -- c ) keycode or 0
; in: -/-
;out: eax:=-1/+ve ebx:=key/xx eflags:=S/NS+Z
qrx:A
	_push 0		; char
	mov ebx,[uref uPINP]
	sys_read EMPTY,esp,1
	mov [uref uPEOFP],eax; save ernum, Z is <eof>, S is ernum, >0 is char(s) received
	neg eax		; -1 on success
	pop ebx		; buffer
	js .r		;?; char received
	xor ebx,ebx
.r:
	ret
;- !csp		( -- )
;-	Save stack pointer in CSP for error checking.
__CODE 4,"!csp",STCSP
	__ENTER
	mov [uref uCSP],esp
	__NEXT
;- pack		( a1 u a2 -- a2 )
;-	store string(b,u) to a, erase up to aligned address.
__CODE 5,"pack",PACKS	; -8
	_add ebx,CELSZ-1
	_and ebx,-CELSZ		; a2 aligned
	mov eax,[esp+4]		; a1
	mov ecx,[esp]		; u
	lea edx,[ebx+ecx]	; a2+u
	_and edx,-CELSZ		; aligned stg end
	mov [esp+4],ebx		;		{ -x- -x- a
	mov [esp],eax		; b=a2 c=u	{  u  a1  a2
	mov dword[edx],0
	jr PLACE.n
;- place	( a1 u a2 -- )
;-	store string(a1,u) to a2, erase up to aligned address
__CODE 5,"place",PLACE	; -48
	pop ecx			;ecx := u
.n:
	mov eax,[esp]		; a1
	__ENTER
	mov [esp],esi		; save UR
	push edi		; save IP
	mov esi,eax		;esi := a1
	lea edi,[ebx+1]		;edi := a2
	mov [ebx],cl		; countbyte
	repz movsb
	pop edi
	pop esi
	pop ebx			; @tos
	__NEXT
;-
;- lc-depend
 __CODE 4,'lc-depend',LCDEP
	 __ENTER
	_and dword[uref uBITSB],~(mcaps)
	 __NEXT
;- lc-ignore
 __CODE 4,'lc-ignore',LCIGN
	 __ENTER
	_or dword[uref uBITSB],mcaps
	 __NEXT
;-
;- search	( a1 u1 a2 u2 -- a3 u3 flg )
;-	find text(a2,u2) in memory at a1, searching max. u1 bytes;
;-	if found ret true flg & ptr a3 to stg, remainig length u3
;-	else ret false flg & a3=a1, u3=u1
 __CODE 4,'search',SEARCH;:ok:
	call search
	__ENTER
	_add PS,CELSZ
	mov ebx,ecx	; swap drop
	__NEXT
;  in: ebx: u2 tos{ ret a2 u1 a1 }
; out: ebx=ret ecx=flg tos{ xx u3 a3 }
search:A
	pop edx		; ret
	rpush edx	; to @tor
	test ebx,ebx
	mov ecx,-1
	jz near .r	;?; empty stg is 'found'
	inc ecx
	cmp ebx,TOS(2)
	mov edx,dword[uref uBITSB]
	jg .r		;?; 'not found' if stg > mem
	mov ecx,TOS(2)	; u1
	rpush edx	;		[ @(bits)
	sub ecx,ebx	; u1-u2
	inc ecx		; d(u) char after end of shorter stg, def''d <nul> by ans-4th
	pushad		; after <pushad>d regs, tos(8+1)...: a2 u1 a1
	mov edi,[esp s_tor+8];D:=a1, mem beginning
.l:
	push edi
	_mov edx,0	; d(u)
	mov eax,edx	; flg
	mov esi,edi	; a1
	mov ecx,ebx	; u1 = u2
	mov edi,[byte esp s_tor+4]; a2
; -------------------------------------------------
;	> ebx:=len2 edi:=stg2 ecx:=len1 esi:=stg1 edx:=(u1-u2); @[bits) in TOR(0)
;  ret	  ebx:=eax:=flag, edi,esi:=xx
	call compare.c
	test ebx,ebx
	pop edi
	readad ecx,ecx
	jz .f		;?; found, ecx=rmg count, edi=a1'
	dec ecx
	readad ebx,ebx	; u2
	writead ecx,ecx	;
	inc edi
	add ecx,ebx
	jg disp .l
	mov ecx,[esp s_tor+4];c:=u1, initial count
	sub ecx,ebx
	mov edi,[esp s_tor+8];D:=a1, mem beginning
	_mov ebx,-1
.f:
	writead eax,ecx	;d(u)'	count
	writead ecx,ebx	; f	flag
	writead edx,edi	; a	addr
	popad
	_add RS,CELSZ
	add ebx,eax	; d(u)'+u2
	not ecx		; f	flag
	mov TOS(2),ebx	; c
	mov TOS(3),edx	; a
.r:
	rpop ebx
	jmp ebx
;- compare	( a1 u1 a2 u2 -- n )
;-	compare strings (a1,u1) & (a2,u2) by subtraction of character code
;-	in stg2 from char. code of stg1 at the rsp. position. assume each stg
;-	terminated by <nul> code, while comparing, for deriving the result.
;-	letter case dependency obeyed as set by lc-depend/ignore.
;-	return n:
;-		1: s1>s2, -1: s1<s2, 0: s1=g2
;-	i.e. difference of 1st different chars determine flag, else length.
; c: ecx,edx
 __CODE 4,'compare',COMPARE;:ok:
	mov ecx,TOS(2)	; u1
	__ENTER
	mov edx,ecx	; u1
	sub edx,@TOS	; u1-u2, result
	test @TOS,@TOS
	jz .l		;?; 2nd empty, s1 > s2, u2=flag
	test ecx,ecx
	jz .l		;?; 1st empty, s1 < s2
; <search) stg-s not empty	{ u2 p2 u1 p1
	mov ecx,dword[uref uBITSB]}
	rpush esi,edi,ecx
	mov edi,TOS(1)	;D: a2
	mov esi,TOS(3)	;S: a1
	mov ecx,@TOS	;c: u2
	call compare
	rpop esi,edi,edx
.l:
	_add PS,3*CELSZ
	__NEXT
;	> ebx:=len2 edi:=stg2 ecx:=len1 esi:=stg1 edx:=(u1-u2); @[bits) in TOR(0)
;  ret	  ebx:=eax:=flag, edi,esi:=xx
compare:A;:ok:<COMPARE)
	cmp ecx,ebx	;u2,u1
	mov eax,edx	;(u1-u2), for result
	jbe .c
	mov ecx,ebx
.t:
	jecxz .s
.c:
	repz cmpsb
	jz .p		; stgs/common part equal, edx/length is result
	test dword TOR(0),mcaps
	movzx ebx,byte[edi-1];c2
	movzx edx,byte[esi-1];c1
	jz .s		;?; case dependently
	movzx edx,byte[edx+thichar];lo>hi
	movzx ebx,byte[ebx+thichar]
	cmp edx,ebx
	jz .t		;?; more
.s:
	sub edx,ebx	; c1-c2
.u:
	mov eax,edx
.p:
	test eax,eax
	mov ebx,eax
	jz .o
	sar ebx,31
	lea ebx,[ebx*2+1]
.o:
	ret		; ret len1-len2
;- same?	( a1 a2 u -- a1 a2 f \ -0+ )
;-	Compare u cells in two strings. Return 0 if identical.
__CODE 5,"same?",SAMEQ	; -116
	mov edx,[uref uBITSB]
	__ENTER
	test ebx,ebx
	mov ecx,ebx
	mov ebx,0
	jng .r
	rpush edi,esi,edx
	mov edi,TOS(1)	;D:=a2
	mov esi,TOS(2)	;S:=a1
	mov ebx,ecx	;c:=u2 =u1
	_mov edx,0
;	> ebx:=len2 edi:=stg2 ecx:=len1 esi:=stg1 edx:=(u1-u2); @[bits) in TOR(0)
;  ret    ebx:=eax:=flag, edi,esi:=xx
	call compare
	rpop edi,esi,edx
.r:
	__NEXT
sameq:A
	mov edx,[uref uBITSB]
	test ebx,ebx
	mov ecx,ebx
	mov ebx,0
	jng .r
	rpush eax,ecx,edi,esi,edx
	mov edi,TOS(1+1);D:=a2
	mov esi,TOS(1+2);S:=a1
	mov ebx,ecx	;c:=u2 =u1
	_mov edx,0
;	> ebx:=len2 edi:=stg2 ecx:=len1 esi:=stg1 edx:=(u1-u2); @[bits) in TOR(0)
;  ret    ebx:=eax:=flag, edi,esi:=xx
	call compare
	rpop rregl
.r:
	ret
;- (find)		( a va -- ca na | a F )
;-	Search a vocabulary for a string. Return ca & na if succeeded.
;original war schon clever gemacht, respekt, glatter knieschu...
__CODE 4,"(find)",FIND	; -80
	mov ecx,TOS(1)	; swap dup
	mov eax,[ecx]	; c@
	__ENTER
	movzx edx,al
	_sub edx,CELSZ-1
	_add ecx,CELSZ
	rpush edx,eax	; 1st dword >r
	mov TOS(1),ecx	; ( a4 va [ @a tmp=c4
.f1:A
	mov ebx,[ebx]	; na
	test ebx,ebx
	jz .f6
	mov eax,[ebx]
	test al,SMUDG
	jnz .fc		;?; marked not findable
	and eax,MNAME	; mask off compilebits
	jz .fc		;?; linked, w/o name
	xor eax,@TOR	; @a
	jz .f2
	test dword[uref uBITSB],mcaps
	jz .fc
	and eax,~(0x20202000)
	jz .f2
.fc:
	_sub ebx,CELSZ
	jmp disp .f1
.f2:A
	_add ebx,CELSZ
	spush
	mov ebx,TOR(1)
	call sameq
	test ebx,ebx
	spop
	jz .f5
.f3:
	_sub ebx,2*CELSZ
	jmp disp .f1
.f5:A; rdrop swap drop cell- dup name> swap
	_sub ebx,CELSZ	; cell-
	mov ecx,[ebx-2*CELSZ];name>
	mov TOS(1),ecx
.r:
	_add RS,2*CELSZ	; rdrop, discard temp
	__NEXT
.f6:A
	_sub dword TOS(1),CELSZ; swap cell- swap
	jmp disp .r
;- .id		( na -- )
;-	Display the name at address. immediates displayed bold
__CODE 3,".id",DOTID; -28
	test ebx,ebx
	__ENTER
	jz .n
	call mrange
	jz .n
	movzx ebx,byte[ecx]	; countbyte
	rpush ebx		; save for rev. video
	_and ebx,NWIDTH
	test byte @TOR,IMEDD
	jz .o
	push ecx
	call vtmd		; bright
	pop ecx
.o:
	inc ecx			; 1st char
	sys_write [uref uPOUP],EMPTY,ebx
	rpop
	test bl,IMEDD
	jz .n
	call vtme		; normal intensity
.n:
	spop
	__NEXT
;- base@	( -- n )
__CODE 3,'base@',BASEF
	spush
	__ENTER
	mov @TOS,[uref uBASE]
	__NEXT
;- unsmudge	( -- )
;-	set 'visibilty'-bit of latest word.
__CODE 1,"unsmudge",UNSMUDGE; -16
	mov edx,(~(SMUDG))&0xff
.n:	__ENTER
	mov ecx,[uref uCRRNT]
	mov ecx,[ecx]
	and byte[ecx],dl
	or byte[ecx],dh
	__NEXT
;- cmpo		( -- )
;-	set 'compile only' flag of latest word.
__CODE 9,"cmpo",CMPLO; -52
	_mov edx,COMPO<<8|255
	jmp disp UNSMUDGE.n
;- immediate  ( -- )
;-	toggle 'immediacy' of latest word.
__CODE 9,"immediate",IMMED; -52
	_mov edx,IMEDD<<8|255
	jmp disp UNSMUDGE.n
;- smudge	( -- )
;-	toggle 'visibilty' of latest word.
__CODE 1,"smudge",SMUDGE; -16
	_mov edx,SMUDG
	__ENTER
	mov ecx,[uref uCRRNT]
	mov ecx,[ecx]
	xor byte[ecx],dl
	__NEXT
;- toggle	( a c -- )
;-	xor byte at a w/ c
__CODE 1,"toggle",TOGGLE; -12
	mov ecx,@TOS
	__ENTER
	spop
	xor byte[@TOS],cl
	spop
	__NEXT
;-
; - Numeric output, single precision
;-

;- digit?	( c base -- u f )
;-	Convert a character to its numeric value. A flag indicates success.
__CODE 6,"digit?",DIGTQ
	__ENTER
	movzx ecx,byte TOS(1); code
	call digitq
	mov TOS(1),ecx	; { u f
	__NEXT
;in: ebx = base, ecx = char-byte
;out:ebx:= flag, ecx:= digit, ah:=char
digitq:A
	cmp bh,0	; base
	movzx ebx,bl
	movzx eax,cl	; char
	mov ah,al	; save char
	jnz .a		;?; no conversion if base@ = 256 (or zero)
	cmp al,'a'
	jc .u		;?; upper case low ascii
	xor al,32
.u:
	sub al,'0'	; #48 $30
	jc .x		;?; not a valid char
	cmp al,10
	jc .b		;?; decimal digit
	cmp al,17
	jc .x		;?; ascii gap
	sub al,7	; #55 $35
.b:
	cmp al,bl
	jnc .x		;?; not in range
.r:
	movzx ecx,al	; char value
	dec bh		; true ;s
.x:
	movsx ebx,bh
	ret
.a:
	cmp cl,' '	; any ctrl char & {bl} terminates ascii mode
	ja .r
	movzx ebx,bh
	ret
;- >number	( dn a u -- dn n | a n )
;-	accumulate to dnumber? w/ stg & count
;-	n:=ff if string fully converted, else n:=remaining count
__CODE 1,'>number',TONUM
	mov edx,ebx
	spop ecx
	jr DNUMQ.t
;- dnumber?	( a -- dn n | a 0 )
;-	Convert a number string to integer. valid for dpl is ',' & '.'
;-	n:=false flag if entire stg converted, else remaining length.
;-	ret (a,0) after complete failure
;-	stg prefices & corresponding radices:
;-		'%'	2		''	12
;-		'!'	4		'$'	16
;-		'&'	8		'"'	256 (ascii, w/o. ".", ",")
;-		'#'	10		'\'	f.p. number (n.i.)
__CODE 7,"dnumber",DNUMQ
	lea ecx,[ebx+1]	; addr
	movzx edx,byte[ebx]; maxlen
	_push 0
	_push 0
.t:
	__ENTER
	call qnumq
	__NEXT
; in: ebx = string, [esp{ ret, accu.hi, accu.lo }]
;out: ebx:= F/addr, ecx:=rmg count edx:=addr [esp{ dnum }]
qnumq:A
	mov eax,[uref uBASE]
	rpush eax	; @base
	call abase
; ebx:=flag|base ecx=:count edx:=addr
	test ecx,ecx	; u
	xchg ecx,edx	;c=a d=u
	jng near .x	;?; empty stg

	rpush ebx,edx	; ebx=sign|base, edx=count
	movzx ebx,bx	; base
	push ecx	; a
	push ebx	; b
	mov dword[uref uDPL],-1
; ebx:=tbase, edx:=stg tor[ count base
.l:
	mov edx,[esp+4]	; a
	movzx ecx,byte[edx]; char
	inc dword[esp+4]
	mov ebx,[esp]	; b
;in: ebx = base, ecx = char-byte
	call digitq
;out:ebx:= flag, ecx:= digit
	test ebx,ebx	; flag
	jns .d		;?; not a digit
	mov eax,[esp+16]; ll
	mul dword[esp]	; a:=ll d:=lh
	mov ebx,eax	; ll
	mov eax,[esp+12]; hh
	mov [esp+12],edx; lh
	mul dword[esp]	; h:=hl, d:=ovf
	add eax,[esp+12]; lh+hl
	add ebx,ecx	; ll':=ll+dig
	adc eax,0	; hh'
	mov [esp+16],ebx; ll
	mov [esp+12],eax; hh
	dec dword[RS]
.n:
	jg disp .l 	; more
.c:
	rpop eax,ecx	; sign & rmng count
	test eax,eax
	jns .p
	neg dword[esp+16]; ll
	adc dword[esp+12],0; Cy
	neg dword[esp+12]; hh
.p:
	mov ebx,[esp+4]	; flag = address of last char
	_add esp,8
	mov edx,ebx
.x:
	mov ebx,ecx
	rpop eax
	mov [uref uBASE],eax
	ret
.d:
	cmp ah,','
	jz .i
	cmp ah,'.'
	jnz .c
.i:
	mov eax,[RS]
	dec eax
	mov [uref uDPL],eax
	mov [RS],eax
	jmp disp .n
;- number?	( a -- n T | d T | a F )
;-	Convert a number string to integer. Push a flag on tos.
;-	dpl@ returns -1 if the result is sing, +ve if double.
;-	optional stg prefices & corresponding radices:
;-		'%'	2		''	12
;-		'!'	4		'$'	16
;-		'&'	8		'"'	256 (ascii, w/o. ".", ",")
;-		'#'	10		'\'	f.p. number (n.i.)
__CODE 7,"number?",NUMBQ; -14
	lea ecx,[ebx+1]	; addr
	movzx edx,byte[ebx]; maxlen
	rpush ebx	; save for error return
	_push 0
	_push 0
	__ENTER
; in: ebx = string, [esp{ ret, accu.hi, accu.lo }]
	call qnumq
;out: ebx:= F/addr, ecx:=rmg count edx:=addr [esp{ dnum }]
	test ecx,ecx
	rpop edx
	jz .r		;?; success
	mov [PS+4],edx	; addr
	_mov edx,0
	jr .d
.r:
	cmp dword[uref uDPL],byte 0
	jns .x
.d:
	_add PS,CELSZ	; swap drop
.x:
	mov ebx,edx
	__NEXT
;- abase  	( ptr1 -- ptr2 u2 sgn base )
;-	ret base according to prefix to number, else ret current base.
;-	single char prefixed -ve numbers may be written as
;-		{prefix}-nnn or, -{prefix}nnn.
;-	n := corresponding radix value, msw is sign flag.
;	n := corresponding radix value, or -1 for f.p. prefix, msw is sign flag.
;-	valid prefices & corresponding radices:
;-		'%'	2		''	12
;-		'!'	4		'$'	16
;-		'&'	8		'"'	256 (ascii, w/o. ".", ",")
;-		'#'	10		'\'	f.p. number (n.i.)
;-	max-len +u adjusted according to prefix or, -ve to limit by 1st non-valid char
__CODE 1,'abase',ABASE
	lea ecx,[ebx+1]	; addr
	movzx edx,byte[ebx]; maxlen
	call abase
	__ENTER
	spush edx	; stg
	spush ecx	; count
	mov edx,ebx
	sar edx,16
	movzx ebx,bx	; base
	push edx	; sgn
	__NEXT
abase:A;subroutine!	; "\"=ascii 92; f6:"ascibase"
; in: ecx = stg, edx = count
;out: ebx:= sgn|base, ecx:= count, edx:= stg
	push ecx	; addr	->tos(2)
	push edx	; len	->tos(1)
	mov ebx,[uref uBASE]; preset n to base@
	dec edx
	jz .x		;?;ret if single char
	cmp byte[ecx],'-'
	jnz .c		;?; +ve
	inc ecx		; +cnt
	not ebx		; sign flag
	not bx		; leave base
.c:;		;<+ve
	cmp byte[ecx],'0'
	jnz .o		;?; try single char praefix
	inc ecx
	cmp byte[ecx],'x'
	jz .s		;?; sedec
	cmp byte[ecx],'X'
	jnz .p		;?; not sedec
.s:
	mov bx,16	; sedecimal
	inc ecx
.r:
	sub ecx,TOS(2); diff.
	add TOS(2),ecx; advance to digit chars
	sub TOS(1),ecx; adjust cnt
.x:;		;<single char
	pop ecx
	pop edx		; clear PS
	ret
.p:A;		;<not '0x..'
	dec ecx
.o:;		;<not sedec.
	push ecx	;count
	push edi	;UR
	mov edi,npref; number base praefices
	mov edx,ebx	; save base@ & sign in edx
	mov ebx,[ecx]
	shl ebx,8
	movzx eax,bh
	mov ecx,npref.e-npref
	repnz scasb		; scan for prefix char
	movsx bx,byte[edi+nbase-npref-1];radix value
	pop edi
	jnz .n		;?; none
	test bl,bl	; radix
	jz .n		;?; prefix not valid
;;	js .f	;?; float
	mov dx,bx	; pass radix
	dec bl
	jnz .f
	mov dx,256	; -> ascii
.f:
	inc dword[esp]	;advance over prefix
.n:; check sign after praefix
	test edx,edx
	js .m
	shr ebx,8
	cmp bh,'-'
	jnz .m
	inc dword[esp]
	not edx
	not dx
.m:
	mov ebx,edx	; radix
	pop ecx
	jr .r
;- dpl@		( .. n )
__CODE 1,'dpl@',DPLF
	spush
	__ENTER
	mov @TOS,[uref uDPL]
	__NEXT
;- >name	( ca -- na | F )
;-	Convert code address to a name address.
__CODE 5,">name",TNAME; -100(+)
	lea ecx,[uref uCRRNT]; current cell-
	__ENTER
.1:	mov edx,[ecx]	; cell+	@ ?dup
	test edx,edx
	lea ecx,[ecx+4]
	jz .0
.2:;	; ebx=ca ecx=va
	mov edx,[edx]	; @
	test edx,edx
	jz .1
	cmp edx,Y
	jc .0
	cmp edx,[uref uBSS]
	jc .5
	cmp edx,[uref uNP]
	jc .0
	cmp edx,[dtib]
	jnc .0
.5:	cmp ebx,[edx-8]	; name> =/=
	jz .3
	_sub edx,4
	jmp disp .2
.3:	mov ebx,edx
	__NEXT
.0:	_mov ebx,0
	__NEXT
;-
;- ver		( -- n )
;-	Return the version number of this implementation.
__CODE 3,"ver",VERSN; -8
	spush
	__ENTER
	mov ebx,((REL*256+VER)*256+EXT)
	__NEXT
;- hi		( -- )
;-	Initialize I/O; print system version.
__CODE 2,"hi",HI; -4
	call stoio
	spush
	mov ebx,HI.s
	jmp disp CTYPES
;-
;-  <--- CONS ============================================

;-
;- 0		( -- n )
;-	constant zero
__CONS 1,"0",ZERO,0

;- cell		( -- n )
;-	ret no. of bytes per cell.
__CONS 4,"cell",CELL,CELSZ

;- bl		( -- 32 )
;-	Return <blank> character code.
__CONS 2,'bl',BLANK,32

;- ''		( -- n )
;-	Return <"> character code.
__CONS 3,"''",QTE,'"'

;-
;-  <--- USER-VARI ============================================

;- sp0		( -- a )
;-	Pointer to bottom of the data stack.
__USER 3, "sp0",S0
;- rp0		( -- a )
;-	Pointer to bottom of the return stack.
__USER 3, "rp0",R0
;- '?key	( -- a ) '
;-	Execution vector of ?KEY.
__USER 5,"'?key",TQKEY
;- 'emit	( -- a ) '
;-	Execution vector of EMIT.
__USER 5,"'emit",TEMIT
;- 'expect	( -- a ) '
;-	Execution vector of EXPECT.
__USER 7,"'expect",TEXPE
;- 'tap		( -- a ) '
;-	Execution vector of TAP.
__USER 4,"'tap",TTAP
;- 'echo	( -- a ) '
;-	Execution vector of ECHO.
__USER 5,"'echo",TECHO
;- 'prompt	( -- a ) '
;-	Execution vector of PROMPT.
__USER 7,"'prompt",TPROM
;- base		( -- a )
;-	Storage of the radix base for numeric I/O.
__USER 4, "base",BASE
;- tmp		( -- a )
;-	A temporary storage location used in parse & find.
__USER 3, "tmp",TEMP; COMPO - quatsch, wozu!?
;- span		( -- a )
;-	Hold character count received by EXPECT.
__USER 4, "span",SPAN
;- >in		( -- a )
;-	Hold the character pointer while parsing input stream.
__USER 3, ">in",TOIN
;- #TIB		( -- a )
;-	Hold the current count in the terminal input buffer.
__USER 4,"#tib",HTIB
;- TIB		( -- a )
;-	Hold the current address of the terminal input buffer.
__USER 5,"(tib)",PTIBP
;- csp		( -- a )
;-	Hold the stack pointer for error checking.
__USER 3, "csp",CSP
;- 'eval	( -- a ) '
;-	Execution vector of EVAL.
__USER 5,"'eval",TEVAL
;- 'number	( -- a ) '
;-	 Execution vector of NUMBER?.
__USER 7,"'number",TNUMB
;- hld		( -- a )
;-	Hold a pointer in building a numeric output string.
__USER 3, "hld",HLD
;- handler	( -- a )
;-	Hold the return stack pointer for error handling.
__USER 7, "handler",HANDL
;- 'm/mod	( -- a )
;-	xec vector of div. primitive for "/mod","/","*/mod","*/"
__USER 6, "'m/mod",TMBYM	;[hp]
;- dpl		( -- a )
;-	posn of decimal fraction marker, or -1
__USER 4,"dpl",DPL		;[hp]
;- (ci)		( -- a )
;-		by compiler/interpreter
__USER 5,"(cpl)",PCPLP		;[hp]
;- (in)		( -- a )
;-	stdin fd
__USER 4,"(in)",PINP		;[hp]
;- (ou)		( -- a )
;-	stdout fd
__USER 4,"(ou)",POUP		;[hp]
;- (er)		( -- a )
;-	stderr fd
__USER 4,"(er)",PERP		;[hp]
;- (kb)		( -- a )
;-	fd for keyboard access
__USER 4,"(kb)",PKBP
;- context	( -- a )
;-	1st vocabulary of search order, voc-stack follows.
__USER 7,"context",CNTXT
%assign _USER _USER+NVOCS*CELSZ		; voc-stack
;- current	( -- a )
;-	Point to the vocabulary to be extended.
__USER 7, "current",CRRNT
;- voc-link	( -- a )
;-	Point to the vocabulary to be extended.
__USER 8, "voc-link",VOCLINK	;[hp]
;- cp, dp	( -- a )
;-	Point to the top of the code dictionary.
__USER 2, "cp",CP
DP:__AWORD 1,'dp',CP; +16
;- np		( -- a )
;-	Point to the bottom of the name dictionary.
__USER 2, "np",NP
;- last		( -- a )
;-	Point to the last name in the name dictionary.
__USER 4, "last",LAST
;- (bits)
;-	system state bits
__USER 6,"(bits)",BITSB
;- 'type
;-	xec vector of "type".
__USER 6,"'type",TTYPE
;- width
;-	significant name length, max length for newly compiled names (n.i.)
__USER 6,"width",WIDTH
;- up
;-	Point to the top of user vari.
__USER 6,"up",UP

;-

;-
;- ============================================
;- Basic I/O
;-

;- spaces	( +n -- )
;-	Send n spaces to the output device.
__COLON 6,"spaces",SPACES
	dd TOR
	dd BRAN,.2
.1:	dd SPACE
.2:	dd DONXT,.1
	dd EXIT

;-
;- numeric
;-

;- 

;- .r		( n +n -- )
;-	Display an integer in a field of n columns, right justified.
__COLON 2,".r",DOTR
	dd TOR,STR4,RFROM,OVERM,SPACES,TYPES,EXIT
;- u.r		( u +n -- )
;-	Display an unsigned integer in n column, right justified.
__COLON 3,"u.r",UDOTR
	dd TOR,BDIGS,DIGS,EDIGS
	dd RFROM,OVERM,SPACES,TYPES,EXIT
;- .		( w -- )
;-	Display a signed integer in free format, preceeded by a space.
__COLON 1,".",DOT
.n:	dd STR4,TYPES,SPACE,EXIT   ;[hp]
;- ?		( a -- )
;-	Display the contents in a memory cell.
__CODE 1,"?",QUEST
	mov ebx,[ebx]
	jmp disp DOT
;- u.		( u -- )
;-	Display an unsigned integer in free format.
__COLON 2,"u.",UDOT
.n:	dd ZERO,UDOTR,SPACE,EXIT
;[hp] from DOT - where it certainly does not belong to!
__CODE 0,"b.",BDOT
	_cmp dword[uref uBASE],10
	jz disp DOT
	jmp disp UDOT
;- u?		( a -- )
;-	unsigned display the contents in a memory cell.
__CODE 1,"u?",UQUEST
	mov ebx,[ebx]
	jmp disp UDOT
;- $.		( u -- )
;-	display sedecimal unsigned number
__CODE 1,"$.",HXDOT
	_mov ecx,16
.1:; n	base@ swap base! swap
	push dword[uref uBASE]
	mov [uref uBASE],ecx
	call DOLST
	dd UDOT,BASES,EXIT
;- #.		( u -- )
;-	display decimal unsigned number
__CODE 1,"#.",DECDOT
	_mov ecx,10
	jmp disp HXDOT.1
;- &.		( u -- )
;-	display sedecimal unsigned number
__CODE 1,"&.",OCDOT
	_mov ecx,8
	jmp disp HXDOT.1
;- %.		( u -- )
;-	display sedecimal unsigned number
__CODE 1,"%.",BINDOT
	_mov ecx,2
	jmp disp HXDOT.1
;-
;- Parsing
;-
; in: eax=char, ebx=stg1, ecx=count1
;out: eax=stg2, ebx=count2
;mod: a,b,c,f
skip:A
	test ecx,ecx
	jng .r
	push edi
	mov edi,ebx
	cmp eax,BL<<8|BL
	jz .b
	repz scasb
;.n:
	inc ecx
.x:
	dec ecx
.q:
	lea ebx,[ecx+1]	; rmg count
	lea eax,[edi-1]	; 1st =/= char
	pop edi
	ret
.r:A;	empty stg
	mov eax,ebx	; a':=a
	mov ebx,ecx	; u':=0
	ret
.b:A;	;cmp al,[edi]+
	scasb		; skip any ctrl and <bl>
	jc .x		;?; higher code
	dec ecx		; bl or lower
	jnz .b
	jr .q		;>; no other chars
; in: eax=char, ebx=stg1, ecx=count1
;out: eax=stg2, ebx=count2
;mod: a,b,c,f
scan:A
	test ecx,ecx
	jng skip.r
	push edi
	mov edi,ebx
	cmp eax,BL<<8|BL
	jz .b
	repnz scasb
	jz .q
.n:
	inc edi		; end of stg & zero if char not found
.x:
	dec ecx
.q:
	lea ebx,[ecx+1]
	lea eax,[edi-1]	; ptr to 1st =/= char
	pop edi
	ret
.b:A;	;cmp al,[edi]+
	scasb		; skip any ctrl and <bl>
	jnc .x		;?; char above <bl>
	dec ecx		; bl or lower code
	jnz .b
	jr .n		;>; no other chars
;- skip		( a +n c -- a' u' )		(l4)
;-	skip leading chars = c of length u string(a,n).
;-	ret posn p' of 1st char =/= c and remaining cnt u'.
;-	scan string(a,n) for 1st occurrence of char =/= c.
;-	specific handling of <bl> including low ctrl-s if c = 0000<bl><bl>
__CODE 1,"skip",SKIP
	mov eax,ebx	;eax:=c
	spop ecx	;ecx:=u
	mov ebx,[PS]	;ebx:=a
	__ENTER
	call skip
	mov [PS],eax	;eax=a', ebx=u'
	__NEXT
;- scan		( a +n c -- a' u' )		(l4)
;-	letter-case dependently scan string(a,n) for 1st occurrence of char = c.
;-	ret posn p' of 1st char = c and remaining cnt u'.
;-	ret u' = 0 and ptr to after stg if dlm not found.
;-	skip leading chars =/= c of string(a,n).
;-	specific handling of <bl> including low ctrl-s if c = 0000<bl><bl>
; c: ecx,edx
__CODE 1,'scan',SCAN
	mov eax,ebx	;eax:=c
	spop ecx	;ecx:=u
	mov ebx,[PS]	;ebx:=a
	__ENTER
	call scan
	mov [PS],eax
	__NEXT
;- parse	( c -- b u )
;-	Scan input stream(tib+@in,#tib-@in), ret counted string delimited by c.
__CODE 5,"parse",PARSE	; -100(ca)
	movzx eax,bl		;a:= char
	__ENTER
	mov ecx,[uref uHTIB]
	mov edx,[uref uTOIN]
	mov ebx,[uref uPTIBP]
	add ebx,edx		;b:=a @tib @>in +
	sub ecx,edx		;c:=u #tib @>in -
; in: eax=c, ebx=a, ecx=u1
	call bparsb		;out: eax=u2, ebx=d, ecx=a, edx=a1, f=xx
	add [uref uTOIN],ebx
	spush edx		; a1
	mov ebx,eax
	__NEXT
;- [parse]	( b1 u1 c -- b2 u2 d )
;-	Scan string delimited by c; if c = <bl> skip leading blanks & ctrls.
;-	Return found string(b2,u2) and disp d from b1 to after next char = c.
;-	ret b2:=b1, u2:=u1, d:=u1 if char c not found
__CODE 7,"[parse]",BPARSB
	mov ecx,[PS]	; c:=u count
	__ENTER
	movzx eax,bl	; a:=c char
	mov ebx,[PS+4]	; b:=a addr
	call bparsb
	mov [PS+4],edx	; tos2 := a2
	mov [PS],eax	; tos1 := u2
	__NEXT
; in: eax=c, ebx=a, ecx=u
;out: eax=u1, ebx=d, ecx=a, edx=a1, f=xx
; >rr bl = if 2dup bl skip else 2dup endif r> scan 
bparsb:A
	cmp al,BL
	push ebx	; a
	jnz .c
	mov ah,al
	call skip
	mov ecx,ebx	; rmg count
	mov ebx,eax	; rmg stg
	mov eax,(BL<<8|BL); char|char
.c:
	push ebx	; a1
	call scan	;a:=a2(1st==c), ebx:=count2
	pop edx		;d:=a1
	test ebx,ebx
	pop ecx		;c:=a
	mov ebx,eax	;b:=a2 or a2+1
	jz .z		;?; char not found
	inc ebx
.z:
	sub eax,edx	; u2   := a1-a2 :HIER: fehler -?-  eax <-> edx  -?-
	sub ebx,ecx	; disp := a2-a
	ret
;
HB:__AWORD 2,"#!",BKSLA	;dummy, non-functional but enabling input redirection
;- \		( -- )				(i)
;-	Ignore following text till the end of line.
__COLON IMEDD+1,"\",BKSLA
	dd ZERO,PARSE,DDROP,EXIT
;- .(         ( -- )				(i)
;-	Output following string up to next ) .
__COLON IMEDD+2,".(",DOTPR
	dd lit(')')		;'
	dd PARSE,TYPES,EXIT
;- (          ( -- )				(i)
;-	Ignore following string up to next ) . A comment.
__COLON IMEDD+1,"(",PAREN
	dd lit(')')		;'
	dd PARSE,DDROP,EXIT
;- char       ( -- c )
;-	Parse next word and return its first character.
__COLON IMEDD|4,"char",CHAR4
	dd BLANK,PARSE,DROP,CAT
	dd LIT,EXIT	;[hp]
;- token      ( -- a   <string> )
;-	Parse a word from input stream and copy it to name dictionary.
;-	truncate name to 31 chars
__COLON 5,"token",TOKEN
	dd BLANK,PARSE,lit(31),MIN
	dd NP,AT4,OVERM,CELLM,PACKS,EXIT
;- word       ( c -- a   <string> )
;-	Parse a word from input stream and copy it to code dictionary.
__COLON 4,"word",WORDD
	dd PARSE,HERE,PACKS,EXIT
;-
;- Dictionary search
;-
;- name?	( a -- ca na | a F )
;-	Search all context vocabularies for a string.
__COLON 5,"name?",NAMEQ
	dd CNTXT,DUP,DAT
	dd EQBRA,.1
	dd CELLM	;;; -?-
.1:	dd TOR
.2:	dd RFROM,CELLP,TORR,AT4,DUP
	dd ZBRA,.3
	dd FIND,QDUP
	dd ZBRA,.2
.3:	dd RDROP,EXIT
;- -find	ccc( -- ca f | a F )
;-	Search all context vocabularies for a string.
;-	f = 0, a = "here" if not found
;-	f = 1 if immediate, else f = -1
__COLON 5,"-find",DFIND
	dd BLANK,WORDD,NAMEQ,findx
__CODE 0,'findf',findx
	rpop IP
	test ebx,ebx
	jz .r
	movzx ebx,byte[ebx]
	ror ebx,imedb+1
	sar ebx,30
	not ebx
.r:
	__NEXT
;- [defined]	ccc( -- f )			(i)
;-	f =/= 0 if word cc was found in current search order
__COLON IMEDD+7,"[defined]",BDEFDB
	dd DFIND,SDROP,EXIT

;- if-nfound	ccc( -- )			(i)
;-	interpret following text input only if word ccc not found
__COLON IMEDD+9,"if-nfound",IFNFND
	dd BDEFDB,NZBRA,BKSLA.nt,EXIT

;- if-found	ccc( -- )			(i)
;-	interpret following text input only if word ccc found
__COLON IMEDD+8,"if-found",IFFND
	dd BDEFDB,ZBRA,BKSLA.nt,EXIT
;-
;- Terminal response, Host system
;-

;-

;- sys		ccc( -- n | )				(i)
;-	get/cpl literal syscall no. n by name ccc
__COLON IMEDD|1,"sys",SYS
	dd BLANK,WORDD,PSYSP,LIT,MCMPL,SC,EXIT
;- [s]		( p a -- p er )
;-	execute syscall by name at <a> with register values at addr. <p>
;-	example: { 0 1 sp@ dup sp@ c" nanosleep" [s] }
__COLON 3,'[s]',BSYSB
	dd PSYSP,SC,EXIT
;- ^h         ( bot eot cur -- bot eot cur )
;-	Backup the cursor by one character.
__COLON 2,"^h",BKSP
	dd DUP,lit(3),PICK	; dup 3 pick >		( b e c -- b e c c -- b e c c b
	dd EQBRA,.1
	dd ONEM,lit(BSP),DUP,XECHO,BLANK,XECHO,XECHO
.1:	dd EXIT
;- accept     ( b u -- b u )
;-	Accept characters to input buffer. Return with actual count.
__COLON 6,"accept",ACCEP
	dd OVER,PLUS,OVER	; over + over 	; b u e u
.1:	dd DDUP			; 2dup =/=
	dd EQBRA,.4		; while
.k:	dd KEY,K2C		;  key key>char
	dd ZBRA,.2		;  if
.e:	dd DUP,EMIT,TAP	;[hp] echo!
	dd BRAN,.1		;  else
.2:	dd TTAP,ATEXE		;   'tap @execute (xec "kTap", for <cr>)
.3:	dd BRAN,.1		; endif repeat
.4:	dd DROP,OVERM,EXIT	; drop over- ;s
;- expect     ( b u -- )
;-	Accept input stream and store count in SPAN.
__COLON 6,"expect",EXPEC
	dd TEXPE,ATEXE,SPAN,STORE,DROP,EXIT; @'expect = accept

;- query      ( -- )
;-	Accept NTIB-1 bytes from input stream to terminal input buffer.
__COLON 5,"query",QUERY
	dd TIB,lit(NTIB-1),TEXPE,ATEXE,HTIB,STORE
	dd DROP,TOIN,OFF,EXIT
;-
;- Error handling
;-

;- catch      ( ca -- 0 | err# )
;-	Execute word at ca and set up an error frame for it.
__COLON 5,"catch",CATCH
	dd SPAT,TOR,HANDL,AT4,TOR; save error frame
	dd RPAT,HANDLS,EXECU	; execute
	dd RFROM,HANDLS		; restore error frame
	dd RDROP,ZERO,EXIT	; no error
;- throw      ( err# -- err# )
;-	Reset system to current local error frame and update error flag.
;-	ANS: ... if err# < 0
__CODE 5,"throw",THROW	; -32+7
	test ebx,ebx	;;;-?- (ANS!)
	jz disp DROP	;;;-?-
	mov RS,[uref uHANDL]
	mov ecx,[RS]	; previous hnd
	mov PS,[RS+4]
	mov IP,[RS+8]
	mov [uref uHANDL],ecx
	_add RS,12
	__NEXT
;- null		( -- a )
;-	Return address of a null cell/string with zero count.
__COLON 5,"null",NULLS
	dd DOVAR                  ; emulate CREATE
.s:	dd 0

;- abort      ( -- )
;-	Reset data stack and jump to QUIT.
__CODE 5,"abort",ABORT; -8
	mov ebx,NULLS.s
	jmp disp THROW
;-   abort"     ( f -- )			(c)
;-              Run time routine of ABORT" . Abort with a message.
__COLON COMPO+6,'abort"',ABORQ
	dd ZBRA,.1		; text flag
	dd DOSTR,THROW		; pass error string
.1:	dd DOSTR,DROP,EXIT	; drop error
;-
;- The text interpreter
;-

;- (i)		( a -- )
;-              Interpret a word. If failed, try to convert it to an integer.
__COLON 10,"(i)",INTER
	dd NAMEQ,QDUP		; ?defined
	dd ZBRA,.1
	dd AT4,lit(COMPO),ANDD	; ?compile only lexicon bits
	dd ABORQ
	stng ," compile only"
	dd EXECU,EXIT		; execute defined word
.1:	dd NUMBER		; convert a number
	dd ZBRA,.2
	dd EXIT
.2:
	dd THROW		; error

;- [          ( -- )				(i)
;-	Start the text interpreter.
__CODE IMEDD+1,"[",LBRAC; -16
	__ENTER
	mov dword[uref uTEVAL],INTER
	__NEXT
;- .ok                ( -- )
;-	Display 'ok' only while interpreting.
__CODE 3,".ok",DOTOK; -12
	spush
	mov ebx,'=>'
	cmp dword[uref uTEVAL],INTER
	jnz .e
	shr ebx,8
.e:
	jmp disp EMIT
;- ?stack     ( -- )
;-	Abort if the data stack underflows.
__COLON 6,"?stack",QSTAC
	dd DEPTH,ZLESS		; check only for underflow
	dd ABORQ
	stng," underflow"
	dd EXIT
;- eval       ( -- )
;-	Interpret the input stream.
;-	exec @(ci) if non-zero, before "eval"
__COLON 4,"eval",EVAL
.1:	dd TOKEN,DUP,CAT	; ?input stream empty
	dd ZBRA,.2
	dd TEVAL,ATEXE,QSTAC	; evaluate input, check stack
	dd BRAN,.1
.2:	dd DROP,TPROM,ATEXE,EXIT; prompt
;-
;- Shell
;-
		
;- file		( -- )
;-	reset 'expect to accept, store I/O vectors for file download
;-	'prompt<-pace, 'echo<-drop, 'tap<-ktap.
__CODE 4,"file",FILE; -34
	mov dword[uref uTPROM],NOOP;;PACE;
	mov dword[uref uTECHO],DROP
.t:
	mov dword[uref uTTAP],KTAP
	__ENTER
	mov dword[uref uTEXPE],ACCEP
	__NEXT
;- terminal	( -- )
;-	reset 'expect to accept, store I/O vectors for terminal interface.
;-	'prompt <- (prompt, from $38 +origin), 'echo <- emit, 'tap <- ktap.
__CODE 4,"terminal",HAND; -16
	mov ecx,[dprompt]	; .s = $38 +origin @
	mov dword[uref uTPROM],ecx
	mov dword[uref uTECHO],EMIT
	jmp disp FILE.t
;- console	( -- )
;-	Initiate terminal interface from "i/o" array.
__CODE 7,"console",CONSO; -12
	mov ecx,[ISLO.v+4]	; '?key
	mov edx,[ISLO.v]	; 'emit
	mov [uref uTEMIT],ecx
	mov [uref uTQKEY],edx
	jmp disp HAND
;- i/o		( -- a )
;-	Array of terminal I/O vectors, dft '?key <- ?key, 'emit <- tx!.
__COLON 3,"i/o",ISLO
	dd DOVAR		; emulate CREATE
.v:	dd QRX,TXSTO		; default I/O vectors
;	tos	nos
;- quit		( -- )
;-	Reset return stack pointer and start text interpreter.
__COLON 4,"quit",QUIT
	dd R0,AT4,RPSTO		; reset return stack pointer
.1:	dd LBRAC		; start interpretation
	dd lit(sgf),OFF
.2:	dd QUERY		; get input
	dd lit(EVAL),CATCH,QDUP	; evaluate input
	dd ZBRA,.2		; continue till error
	dd TPROM,AT4,TOR	; save input device
	dd CONSO
	dd NULLS,OVER		; ?display error message
	dd EQBRA,.3
	dd SPACE,COUNT
.c:
	dd TYPES		; error message
	dd DOTQP
	stng," ? "
.3:;>:todo:; test (eof), close file, rst previous source or kbd (or bye?)
	dd RDROP
	dd PRESET,DROP		; some cleanup
	dd BRAN,.1

__NCOLON 0,'<sys>',SYSA		;<;from "sys"
	dd BRAN,QUIT.c
;-
;- The compiler
;-
__COLON IMEDD|1,"[']",BTICKB
	dd TICK,LIT
.x:
	dd EXIT
;-   '          ( -- ca )
;-              Search context vocabularies for the next word in input stream.
__COLON 1,"'",TICK
	dd TOKEN,NAMEQ		; ?defined
	dd NZBRA,BTICKB.x
	dd THROW		; error
;- [compile]  ( --  <string> )				(i)
;-	Compile the next immediate word into code dictionary.
__COLON IMEDD+9,"[compile]",BCOMP
	dd TICK,COMMA,EXIT
;- compile    ( -- )					(c)
;-	Compile the next address in colon list to code dictionary.
__COLON COMPO+7,"compile",CMPL
.n:	dd RFROM,DUPF,COMMA		; compile address
	dd CELLP,TOR,EXIT		; adjust return address
;- literal    (C: w -- )(X: w -- w )		(i)
;-	Compile tos to code dictionary as an integer literal.
;-	noop while interpreting
__COLON IMEDD+7,"literal",LIT
	dd SZBRA,.x
	dd CMPL,DOLIT,COMMA
.x:	dd EXIT
;- -compile    ( -- )					(c)
;-	xec if interpreting, else compile next address in colon list to code dictionary.
__COLON COMPO|7,"-compile",MCMPL
	dd SZBRA,.x
.n:	dd RFROM,DUPF,COMMA; compile address
	dd CELLP,TOR
.x:	dd EXIT			; adjust return address
;-
;- char. strings
;-

; '' word count
;__NCOLON 0,'qwc',QWC; 0/0
;	dd QTE,WORDD,COUNT,EXIT
;-	
; - ["]		( -- )
; -	Compile a literal string, up to next '"'
__NCOLON 1,'["]',STRCQ;<." ,c" abort); was <$,">
	dd QTE,WORDD,COUNT	; move string to code dictionary
	dd PLUS,ALIGNED		; calculate aligned end of string
	dd CP,STORE,EXIT	; adjust the code pointer
; - [c"]		( -- a )				(c)
; -	Run time routine compiled by {,c"}. Ret address of compiled string.
__NCOLON COMPO+1,'[c"]',DOSTR;<head (.") ,c" abort	; ex do$
	dd RFROM,RAT,RFROM,COUNT,PLUS
	dd ALIGNED,TOR,SWAP,TOR,EXIT
;- (c")
;-	xec [c"]
__COLON COMPO+1,'(c")',CDOSTR;<head (.") ,c" abort	; ex do$
	dd DOSTR,EXIT
;- ,c"		(C: -- )( -- a )			(i)
;-	Compile runtime code & inline string literal.
__COLON IMEDD+2,',c"',STRQ;<c")	; was <$">
	dd CMPL,CDOSTR,STRCQ,EXIT
;- c"		ccc(C: -- )( -- a )			(i)
;-	executing: address of following string, stored at {here}
;-	compiling: Compile a literal string up to next <">.
__COLON	IMEDD+2,'c"',CQUOTE;[hp]
	dd SZBRA,.x
	dd STRQ,EXIT		; cpl
.x:	dd QTE,WORDD,EXIT	; xec
;- (s")		( -- a u )				(c)
;-	Run time routine compiled by {,s"}. Ret address & count of compiled string.
__COLON COMPO+3,'(s")',STRQP
	dd DOSTR,COUNT,EXIT
;- ,s"		(C: -- )( -- a u )			(i)
;-	Compile runtime code & inline counted string literal.
__COLON IMEDD+2,',s"',STRSQ;<s")
	dd CMPL,STRQP,STRCQ,EXIT
;- s"		ccc(C: -- )( -- a u )			(i)
;-	executing: address and count of following string, in parse area
;-	compiling: Compile a literal string up to next <">
__COLON	IMEDD+2,'s"',SQTE
	dd SZBRA,.x
	dd STRSQ,EXIT		; cpl
.x:	dd QTE,WORDD,COUNT
	dd EXIT	; xec
;- p"		ccc(C: -- )( -- a u )			(i)
;-	executing: address and count of following string, at pad
;-	compiling: Compile a literal string up to next <">
__COLON	IMEDD+2,'p"',PQTE
	dd SZBRA,.x
	dd STRSQ,EXIT		; cpl
.x:	dd QTE,WORDD,COUNT
	dd PAD,PLACE,PAD,COUNT,EXIT; xec
;- (.")		( -- )					(c)
;-	Run time routine of ." . Output a compiled string.
__NCOLON COMPO+3,'(.")',DOTQP;<ok etc, sys-msgs	; ex ."|
	dd DOSTR,CTYPES,EXIT
;- ."		ccc( -- )( -- )				(i)
;-	Compile an inline string literal to be typed out at run time.
__COLON IMEDD+2,'."',DOTQ
	dd SZBRA,.s
	dd CMPL,DOTQP,STRCQ,EXIT
.s:	dd QTE,PARSE,TYPES,EXIT
;- sliteral	(C: a u -- )( -- a u )
;-	compile a counted string literal.
;-	NOTE:	because of system structure an immediate input 
;-		string must be on one source line w/ "sliteral".
__COLON IMEDD+2,'sliteral',SLITERAL
	dd CMPL,STRQP,DDUP,HERE,PACKS,DROP
	dd ONEP,ALIGNED,CP,PSTOR,DROP,EXIT
;-
;-	
;- Flow control
;-

;- recurse	( -- )					(i)
;-	re-enter the current word.
__COLON IMEDD+7,"recurse",RECUR
	dd LATEST,NAMET,COMMA,EXIT
;- do		( -- a )				(i)
__COLON IMEDD+2,"do",DO4
	dd CMPL,PDOP,HERE,EXIT
;- +loop	( a -- )				(i)
__COLON IMEDD+4,"+loop",PLOOP4
	dd CMPL,PPLOOP,COMMA,EXIT
;- loop		( a -- )				(i)
__COLON IMEDD+4,"loop",LOOP4
	dd CMPL,PLOOP,COMMA,EXIT
;- -leave	( -- )					(i)
__COLON IMEDD+6,'-leave',MLEAVE
	dd CMPL,PMLEAVEP,EXIT
;- for		( -- a )				(i)
;-	Start a FOR-NEXT loop structure in a colon definition.
__COLON IMEDD+3,"for",FOR
	dd CMPL,TOR,HERE,EXIT
;- begin	( -- a )				(i)
;-	Start an infinite or indefinite loop structure.
;-> re "here" -12
;- next		( a -- )				(i)
;-	Terminate a FOR-NEXT loop structure.
__COLON IMEDD+4,"next",NEXT
	dd CMPL,DONXT,COMMA,EXIT
;- until	( a -- )				(i)
;-	Terminate a BEGIN-UNTIL indefinite loop structure.
__COLON IMEDD+5,"until",UNTIL
	dd CMPL,ZBRA,COMMA,EXIT
;- again  	( a -- )				(i)
;-	Terminate a BEGIN-AGAIN infinite loop structure.
__COLON IMEDD+5,"again",AGAIN
	dd CMPL,BRAN,COMMA,EXIT
;- if		( -- A )				(i)
;-	Begin a conditional branch structure.
__COLON IMEDD+2,"if",IFF
	dd CMPL,ZBRA,HERE,ZCOMMA,EXIT
;- ahead      ( -- A )					(i)
;-	Compile a forward branch instruction.
__COLON IMEDD+5,"ahead",AHEAD
	dd CMPL,BRAN,HERE,ZCOMMA,EXIT
;- repeat     ( A a -- )				(i)
;-	Terminate a BEGIN-WHILE-REPEAT indefinite loop.
__COLON IMEDD+6,"repeat",REPEA
	dd AGAIN,RESLTO,EXIT
;- then       ( A -- )					(i)
;-	Terminate a conditional branch structure.
TH:__AWORD IMEDD+4,"then",RESLTO
;- endif       ( A -- )					(i)
;-	Terminate a conditional branch structure.
THENN:__AWORD IMEDD+5,"endif",RESLTO
;- aft                ( a -- a A )			(i)
;-	Jump to THEN in a FOR-AFT-THEN-NEXT loop the first time through.
__COLON IMEDD+3,"aft",AFT
	dd DROP,AHEAD,BEGIN,SWAP,EXIT
;- else       ( A -- A )				(i)
;-	Start the false clause in an IF-ELSE-THEN structure.
__COLON IMEDD+4,"else",ELSEE
	dd AHEAD,SWAP,THENN,EXIT
;- while      ( a -- A a )				(i)
;-	Conditional branch out of a BEGIN-WHILE-REPEAT loop.
__COLON IMEDD+5,"while",WHILE
	dd IFF,SWAP,EXIT
;- abort"     ( --  <string> )				(i)
;-	Conditional abort with an error message.
__COLON IMEDD+6,'abort"',ABRTQ
	dd CMPL,ABORQ,STRCQ,EXIT
;-
;- Name compiler
;-

;- ?unique	( a -- a )
;-	Display a warning message if the word already exists.
__COLON 7,"?unique",UNIQU
	dd DUP,NAMEQ		; ?name exists
	dd ZBRA,.1
;:HIER:	dd WARNINGF,ZBRA,.1
	dd DOTQP		; redefinitions are OK
	stng," redef'd "	; but the user should be warned
	dd OVER,CTYPES		; just in case its not planned
.1:	dd DROP,EXIT

;- head		( na -- )
;-	Build a new dictionary name using the string at na.
__COLON 3,"head",HEAD
	dd DUP,CAT		; ?null input
	dd ZBRA,.1
	dd UNIQU		; ?redefinition
	dd DUP,LAST,STORE	; save na for vocabulary link
	dd HERE,ALIGNED,SWAP	; align code address
	dd CELLM		; link address
	dd LATEST,OVER,STORE
	dd CELLM,DUP,NP,STORE	; adjust name pointer
	dd SWAP,CELLP,ONEM,SWAP	; adjust to direct entry to <call...> ;[hp]
	dd STORE,EXIT		; save code pointer
.1:	dd DOSTR
	stng," name "		; null input
	dd THROW
;-
;- Forth compiler
;-

;- (c)		( a -- )
;-	Compile next word to code dictionary as a token or literal.
;-	xec (ci) if non-zero, immediately after "find"
__COLON 8,"(c)",SCOMP
	dd NAMEQ,QDUP		; ?defined
	dd PCPLP,ATEXE
	dd ZBRA,.2
	dd AT4,lit(IMEDD),ANDD	; ?immediate
	dd ZBRA,.1
	dd EXECU,EXIT		; its immediate, execute
.1:	dd COMMA,EXIT		; its not immediate, compile
.2:	dd NUMBER		; try to convert to number
	dd ZBRA,.3
	dd LIT
	dd DPLF,ONEP,ZBRA,.x
	dd LIT
.x:	dd EXIT		; compile number as integer
.3:	dd THROW		; error
;- lkw	( -- )
;-	Link a new word into the current vocabulary.
__COLON 5,"lkw",LINKW	; ex overt
	dd LAST,AT4,CRRNT,AT4,STORE,EXIT
;- ;		( -- )			(C,I)
;-	Terminate a colon definition.
__COLON IMEDD+COMPO+1,";",SEMIS
	dd CMPL,EXIT,LBRAC,UNSMUDGE,EXIT;LINKW,EXIT
;- ]		( -- )
;-	Start compiling the words in the input stream.
__CODE 1,"]",RBRAC
	__ENTER
	mov dword[uref uTEVAL],SCOMP
	__NEXT
;;	dd lit(SCOMP),TEVAL,STORE,EXIT;
;-   call,      ( ca -- )
;-              Assemble a call instruction to ca.
__COLON 5,"call,",CALLC
	dd lit(ACALL),COMMA,HERE	; Direct Threaded Code, 3-alignment & call opr
	dd CELLP,SUBB,COMMA,EXIT	; pc-relative call
;- :          ( --   <string> )
;-	Start a new colon definition using next word as its name.
 __COLON 1,":",COLON
	dd TOKEN,HEAD
	dd LINKW,SMUDGE
	dd lit(DOLST),CALLC,RBRAC,EXIT
;-
;- Defining words
;-

;- user       ( u --   <string> )
;-	Compile a new user variable.
__COLON 4,"user",UVARI;USER - seems to be already defined, somewhere in the vicinity of the "nasm" mystery...
	dd TOKEN,HEAD,LINKW
	dd lit(DOLST),CALLC
	dd lit(DOUSE),COMMA
	dd COMMA,EXIT
;- create     ( --   <string> )
;-	Compile a new array entry without allocating code space.
__COLON 6,"create",CREAT
	dd TOKEN,HEAD,LINKW
	dd lit(DOLST),CALLC
	dd lit(DOVAR),COMMA,EXIT
;- variable   ( --   <string> )
;-	Compile a new variable initialized to 0.
__COLON 8,"variable",VARIA
	dd CREAT,ZCOMMA,EXIT
;- does>	( -- addr )
;-	modify latest created word to jump into the DOES part 
;-	of a defining word with its pfa on the data stack.
__COLON IMEDD+5,'DOES>',DOES
	dd lit(DDOES),COMMA
	dd lit(SDOES),CALLC,EXIT
;-
;- Tools
;-

;- kbd'		ccc( -- )			(i)
;-	force word ccc executing w. stdin from keyboard
__COLON IMEDD+4,"kbd'",KBDT
	dd STATEF,ZBRA,.i
	dd CMPL,PKBDTP,EXIT
.i:	dd KBB,TICK,EXECU,BKB,EXIT
;
__NCOLON 0,"[kbd']",PKBDTP
	dd KBB,RFROM,DUP,CELLP,TOR,ATEXE,BKB,EXIT
;- ptype      ( b u -- )
;-	Display a string. Filter non-printing characters.
__COLON 5,"ptype",UTYPE
	dd TOR			; start count down loop
	dd BRAN,.2		; skip first pass
.1:	dd COUNT,TCHAR,EMIT	; display only printable, increment address
.2:	dd DONXT,.1		; loop till done
	dd DROP,EXIT
;
__NCOLON 0,'da',DUMPA; ( a u -- a u ) display a
	dd OVER,lit(8),UDOTR,SPACE,EXIT
;- dm		( a u -- a+u )
;-	Dump u bytes from a, leaving a+u on the stack.
__NCOLON 0,"dm",DUMPP
	dd CRR,lit(16),DDUP	; display numeric
	dd DUMPA,ONEM,TOR
.1:	dd COUNT,lit(3),UDOTR	; formatted display numeric data
.2:	dd DONXT,.1		; loop till done
	dd MROT,SPACE,SPACE,UTYPE; display printable characters
	dd EXIT
;- ndump	( -- )
;-	dump next 128 bytes
__CODE 5,"ndump",RDUMP; -12
	spush
	push dword[dmp+8]
	mov ebx,[dmp+4]
	jr DUMP4
;- rdump	( -- )
;-	repeat last 128 bytes, aligned
__CODE 5,"rdump",NDUMP; -16
	spush
	push dword[dmp]
	mov ebx,[dmp+4]
	jr DUMP4
;- dump       ( a u -- )
;-	Dump u bytes from a, in a formatted manner.
__COLON 4,"dump",DUMP4
	dd DDUP,SWAP,lit(dmp),DSTOR
	dd BASEF,TOR,HEX	; save radix, set hex
	dd DUMPA,OVER,lit(15),TOR
.1:	dd DUP,lit(15),ANDD,lit(3),UDOTR,ONEP
.2:	dd DONXT,.1,DROP
	dd lit(16),SLASH,TOR	; count lines
DUMP1:	dd DUMPP,DONXT,DUMP1	; loop till done
	dd lit(dmp+8),STORE,RFROM,BASES; restore radix
	dd EXIT
;- .s         ( ... -- ... )
;-	Display the contents of the data stack.
__COLON 2,".s",DOTS
	dd CRR,DEPTH		; stack depth
	dd TOR			; start count down loop
	dd BRAN,.2		; skip first pass
.1:	dd RAT,PICK
	dd BDOT			;[hp] index stack, display (un)signed contents
.2:	dd DONXT,.1		; loop till done
	dd DOTQP
	stng,":sp "
	dd EXIT
;- ?csp		( -- )
;-	Abort if stack pointer differs from that saved in CSP.
__COLON 4,"?csp",QCSP
	dd SPAT,CSP,AT4,XORR	; compare pointers
	dd ABORQ		; abort if different
	stng,"stack"
	dd EXIT
;- see		( -- } <forth code> )
;-	A simple hi-level thread decompiler. exit on (cell) == 0.
__COLON 3,"see",SEE
	dd TICK			; parse arg, get xt
	dd DUP,CAT,lit(0xE8),XORR,NZBRA,.5
	dd ONEP			; skip to next cell
	dd DUP,CELLP,BDOT,lit(10),SPACES
.1:; walk the thread cells        one_before_curr.
	dd CELLP		; cur''
	dd DUPF			; cur, (cur)
	dd ZBRA,.4		; cur } exit if 0
; (cell) is non-zero                                      
	dd DUPF			; cur, (cur)
	dd TNAME		; cur, nf or 0
	dd DUP,Q4TH,ZBRA,.2	; cur, nf or 0
; (cell) is in 4th range
	dd DOTID,SPACE,SPACE	; cur
	dd BRAN,.1
.2:; code header cell?	; cur, nf or 0    
	dd DROP,DUPF		; cur, (cur)
	dd lit(ACALL)		; cur, (cur), ..call..
	dd EQUAL		; cur, flag
	dd NZBRA,.4		; cur
	dd SPACE
.0:	dd DUPF,BDOT		; cur
	dd CRR,DUP,BDOT,lit(10),SPACES; display addr
	dd BRAN,.1		; cur
.5:
	dd DOTQP
	stng," prim "
.4:	dd DROP,EXIT

;- words	( -- )
;-	Display the names in the context vocabulary.
__COLON 5,"words",WORDS
	dd CRR,CNTXT,AT4	; only in context
.1:	dd AT4,QDUP		; ?at end of list
	dd ZBRA,.2
	dd DUP,SPACE,DOTID	; display a name
	dd CELLM,BRAN,.1
.2:	dd EXIT
;-
;- Hardware reset
;-

;- 'boot	( -- a ) '
;-	The application startup vector.
__COLON 5,"'boot",TBOOT
	dd DOVAR
	dd app_to_boot		; application to boot

;- warm		( -- )
;-	partially re-initiate the system
__CODE 4,"warm",JWARM
	spush
.j:	jmp dword[origin+4]
;
__NCOLON 1,'warm',WARM
	dd BRAN,COLD.2
;- cold		( -- )
;-	re-initiate the system
__CODE 4,"cold",JCOLD
	jmp dword[origin]; w/ short uvari init: dp, np, latest
;	The hilevel cold start sequence.
__NCOLON 1,'cold',COLD
.1:	dd IUSER		; initialize user area, data stack and TIB
.3:	dd TBOOT,ATEXE		; application boot, dft {!io}
	dd PRESET
	dd CUSER
.2:
	dd DROP
	dd FORTH
	dd CNTXT,AT4,DUP	; initialize search order
	dd CRRNT,DSTOR		; { forth definitions }
	dd LCIGN		; find letter-case independently
	dd lit(QUIT),CATCH	; start interpretation
	dd JCOLD		; just in - which?! - case

;- ===============================================================
DATASEG
	__DATASEG__
DTOP:

LASTN:	equ	_NAME
;
%ifdef def_vocs
CODEROO:equ	ROOCODE
CODESYS:equ	SYSCODE
;
LASTROO:equ	ROONAME
LASTSYS:equ	SYSNAME
%endif
CODEFTH:equ	FTHCODE
LASTFTH:equ	FTHNAME

UDATASEG
utattr:	ELF_BSTRUC termios,.c_iflag,.c_oflag,.c_cflag,.c_lflag,.c_line,.c_cc
.e:
sgf:	resd 1	; segfaults count
dmp:	resd 3	; dump address & count
up2:	resd 1	; initial U0

	alignb PAGE_SIZE
BSSTOP:; bot of application dictionary, data & (hi-level-)code, i.e. 'compilespace'

END

;- eforth.asm <eof>
